; <?php /*
; $Id: servers.php,v 1.2 2002/02/27 17:54:07 admin Exp $
; +------------------------------------+
; |   Frederick Webmail servers file   |
; +------------------------------------+
;
; About this file
; ===============
;
; This file is used if you want to only allow access to a certain set of servers.
; For example if you have three servers, and you only want your users to use these
; three, you would specify them in this file, and set servers_strict to On. If you're
; not bothered then you can set servers_strict to Off, however the default settings
; for the login page server/type/port will be taken from the first set of server
; settings (initially marked as "Default Server"). It's therefore very important that
; you have at least one set of server settings in here.
;
; If this file is changed and thus the last modified time changed, it will be
; re-read. If the last modified time does not change, it will not be re-read.
;
; If you wish to comment out an entry in this file, put a semi-colon (;) at the
; start of the line. Similarly, if you wish to uncomment an entry, remove the semi-colon.


; This setting determines, as mentioned above, whether the users of Frederick will be
; limited to the server settings in this file or not. If you set this to On and have
; multiple servers

servers_strict = Off


[Default Server]


; This is the IP address or hostname of the IMAP/POP3 server you're connecting to.

srvr = localhost


; This is the port of the IMAP/POP3 server you're connecting to. It's usually 143 for IMAP and
; 110 for POP3.

port = 143


; This is the type of server you're connecting to, either imap or pop3 (note the lowercase!).

type = imap


; If you're using IMAP then you should set this to the folder prefix appropriate for your server.
; With UW-Imap this is usually "mail/" or "Mail/", whilst with Courier or Cyrus this is usually
; "INBOX."

fold = mail/


; The following smtp options are optional. If not specified defaults will be applied. You should
; also see the FAQ entry regarding how Frederick determines how to send mail. Note that all of
; these entries are commented out by default.

; This is your smtp server. It can be the same as or different to your imap/pop3 server. If not
; specified the imap/pop3 login server will be used instead.

smtp_srvr = localhost


; This is the port for the smtp server. If not specified port 25 will be used.

smtp_port = 25


; This setting determines who Frederick says it is when connecting to the SMTP server. If not specified
; then the current SERVER_NAME will be used, ie the server name displayed in the browsers address bar.

smtp_helo = 


; This setting determines whether SMTP authentication will be used or not when connecting to the smtp
; server. Should be set to either "On" or "Off".

smtp_auth = Off


; The username and password to be used for smtp authentication. This is currently one setting for all
; however it will be changed soon.

smtp_user = 
smtp_pass = 


; This setting determines which users have access to the admin section. This is a per server setting.
; Multiple admin users can be specified by comma seperating the usernames.

admin = adminuser1,adminuser2,adminuser3

; Here follows some example entries for pseudo servers. Note they are all commented out, and none will
; work (probably...). If you uncomment them, ensure there is no leading whitespace (spaces or tabs).



;[Example Server 1]
;
;srvr = imap.example.com
;port = 143
;type = imap
;fold = INBOX.
;smtp_srvr = smtp.example.com
;admin = joep


;[Example Server 2]
;
;srvr = pop3.example.com
;port = 110
;type = pop3
;smtp_srvr = smtp.example.com
;smtp_port = 25
;smtp_auth = On
;smtp_user = smtpsend
;smtp_pass = djief83rhnj
;admin = joep,joec
 
 
; Don't change the following line...
; */ ?>