<?php
/***************************************
** Filename.......: admin.hosts.php
** Project name...: Frederick Webmail
** Last Modified..: 07 November 2001
** Copyright......: Richard Heyes 2001
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'admin.hosts.php');

	if($SESSION['login']['admin_status'] !== TRUE){
		fred::redirect('index.php', lang('no_admin_rights'));
	}

/***************************************
** Check for any error message
***************************************/

	fred::error_msg($error_msg);

/***************************************
** First time in, display the template.
***************************************/

	if(!isset($HPV) OR empty($HPV)){

		$defined_hosts =& $SESSION['common']['hostinfo']; // Shortcut

		foreach($defined_hosts as $key => $value){
			$hosts[] = array('host_id' => $key, 'host_desc' => htmlspecialchars($value['description']));
		}

		$TPL['template'] = 'admin.hosts.html';
		include($CONFIG['includes'].'template.wrapper.inc');
		exit;

/***************************************
** Submit button hit, do some stuff.
***************************************/

	}else{

		/***************************************
        ** Walk through what was submitted checking
		** for changes, and also new hosts.
        ***************************************/

		while(list($key, $value) = each($HPV)){

			if(substr($key, 0, 10) == 'host_desc_' AND substr($key, -5) != '_orig'){
				$host_id = substr($key, 10);

				// Update with new description
				if($value != $HPV[$key.'_orig'] AND !empty($value)){
					$SESSION['common']['hostinfo'][(int)$host_id]['description'] = $value;
					$result = save_hostinfo();
					// FIXME Add some checks here for success? Maybe one day.
					continue;

				// Empty, delete this host
				}elseif($value != $HPV[$key.'_orig'] AND empty($value)){
					unset($SESSION['common']['hostinfo'][$host_id]);
					$result = save_hostinfo();
					// FIXME Add some checks here for success? Maybe one day.
					continue;
				}
			}

			if(substr($key, 0, 14) == 'new_host_desc_' AND !empty($value)){

				$new_host['description'] = $value;
				$new_host['urls']        = array();
				$new_host['tpls']        = array();
				$new_host['settings']    = array(
													'allow_html_email'       => FALSE,
													'add_username_server'    => FALSE,
													'mail_send'              => 'smtp',
													'default_tpl_set'        => 'default',
													'strip_unsafe_tags'      => TRUE,
													'remove_external_images' => TRUE,
													'encrypt_user_data'      => 0
												);

				$SESSION['common']['hostinfo'][] = $new_host;
				$result = save_hostinfo();
				// FIXME Add some checks here for success? Maybe one day.
				continue;
			}
		}

		/***************************************
        ** Redirect back unto ourselves.
        ***************************************/

		fred::redirect('redirect.php?to=admin.hosts.php');
	}
?>
