<?php
/***************************************
** Filename.......: admin.host_urls.php
** Project name...: Frederick Webmail
** Last Modified..: 09 November 2001
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'admin.hosts.php');

	if($SESSION['login']['admin_status'] !== TRUE){
		fred::redirect('index.php', lang('no_admin_rights'));
	}

/***************************************
** Error msg.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Check we've been handed a host_id
***************************************/

	if(!isset($SESSION['admin']['host_id']) AND !isset($HPV['host_id']) ){
		fred::redirect('admin.php', lang('no_host_id'));
	}else{
		$host_id = isset($SESSION['admin']['host_id']) ? (int)$SESSION['admin']['host_id'] : (int)$HPV['host_id'];
	}

/***************************************
** First time in, display template.
***************************************/

	if(!isset($HPV['submit'])){

		// Get host description
		$host_desc = get_host_desc($host_id);

		// Get all urls for this host
		foreach($SESSION['common']['hostinfo'][$host_id]['urls'] as $key => $value){
			$hosts_urls[] = array(
								'id'       => $key,
								'hostname' => $value['host'],
								'port'     => $value['port']
								);
		}

		$TPL['template'] = 'admin.hosts_urls.html';
		include($CONFIG['includes'].'template.wrapper.inc');
		exit;

/***************************************
** Submit button hit
***************************************/

	}else{

		/***************************************
        ** Walk through what was submitted checking
		** for changes, and also new fred_hosts.
        ***************************************/

		while(list($key, $value) = each($HPV)){

			if(substr($key, 0, 9) == 'hostname_' AND substr($key, -5) != '_orig'){
				$url_id = substr($key, 9);

				// Update with new hostname and port
				if( ($value != $HPV[$key.'_orig'] AND !empty($value)) OR ($HPV['port_'.$url_id] != $HPV['port_'.$url_id.'_orig']) ){
					$HOSTINFO['urls'][$url_id] = array('host' => $value, 'port' => (int)$HPV['port_'.$url_id]);
					if(save_hostinfo()){
						$SESSION['common']['error_msg'] = lang('changes_saved');
					}
					continue;


				// Empty, delete this host
				}elseif($value != $HPV[$key.'_orig'] AND empty($value)){
					unset($HOSTINFO['urls'][$url_id]);
					if(save_hostinfo()){
						$SESSION['common']['error_msg'] = lang('changes_saved');
					}
					continue;
				}
			}

			if(substr($key, 0, 8) == 'new_url_' AND !empty($value)){
			
				$port = $HPV['new_port_'.substr($key, 8)];
				if(empty($port))
					$port = 80;

				$SESSION['common']['hostinfo'][$host_id]['urls'][] = array('host' => $value, 'port' => $port);
				if(save_hostinfo()){
					$SESSION['common']['error_msg'] = lang('changes_saved');
				}
				continue;
			}
		}

		/***************************************
        ** Redirect back unto ourselves.
        ***************************************/

		fred::redirect('redirect.php?to=admin.hosts_urls.php?host_id='.$host_id.'');
	}
?>
