<?php
/***************************************
** Filename.......: admin.settings.php
** Project name...: Frederick Webmail
** Last Modified..: 14 November 2001
** Copyright......: Richard Heyes 2001
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'admin.php');

	if($SESSION['login']['admin_status'] !== TRUE){
		fred::redirect('index.php', lang('no_admin_rights'));
	}

/***************************************
** Check for any error message
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Submit button hit, do some stuff.
***************************************/

	if(!empty($HPV)){

		$host_id   = $SESSION['admin']['host_id'];
		$host_desc = get_host_desc($host_id);
		$hosts     = $SESSION['common']['hostinfo'];

		$hosts[$host_id]['settings']['allow_html_email']       = isset($HPV['allow_html_email'])       ? TRUE : FALSE;
		$hosts[$host_id]['settings']['strip_unsafe_tags']      = isset($HPV['strip_unsafe_tags'])      ? TRUE : FALSE;
		$hosts[$host_id]['settings']['remove_external_images'] = isset($HPV['remove_external_images']) ? TRUE : FALSE;
		$hosts[$host_id]['settings']['add_username_server']    = isset($HPV['add_username_server'])    ? TRUE : FALSE;
		$hosts[$host_id]['settings']['http_compression']       = isset($HPV['http_compression'])       ? TRUE : FALSE;
		$hosts[$host_id]['settings']['cache_email_list']       = isset($HPV['cache_email_list'])       ? TRUE : FALSE;
		$hosts[$host_id]['settings']['refresh_email_list']     = isset($HPV['refresh_email_list'])     ? TRUE : FALSE;
		$hosts[$host_id]['settings']['cache_email_folders']    = isset($HPV['cache_email_folders'])    ? TRUE : FALSE;

		$hosts[$host_id]['settings']['encrypt_user_data'] = (string)$HPV['encrypt_user_data'];
		$hosts[$host_id]['settings']['mail_send']         = (string)$HPV['mail_send'];

		// Save the preferences
		if(save_hostinfo()){
			$SESSION['common']['error_msg'] = lang('changes_saved');
		}

		/***************************************
        ** Redirect back unto ourselves.
        ***************************************/

		fred::redirect('redirect.php?to=admin.settings.php');
	}

/***************************************
** Display the stuff
***************************************/

	$host_id   =& $SESSION['admin']['host_id'];
	$host_desc = get_host_desc($host_id);
	$hosts     =& $SESSION['common']['hostinfo'];

	$form_allow_html_email       = (@$hosts[$host_id]['settings']['allow_html_email']      == TRUE) ? 'checked="checked"' : '';
	$form_strip_unsafe_tags      = ($hosts[$host_id]['settings']['strip_unsafe_tags']      == TRUE) ? 'checked="checked"' : '';
	$form_remove_external_images = ($hosts[$host_id]['settings']['remove_external_images'] == TRUE) ? 'checked="checked"' : '';
	$form_add_username_server    = (@$hosts[$host_id]['settings']['add_username_server']   == TRUE) ? 'checked="checked"' : '';
	$form_http_compression       = (@$hosts[$host_id]['settings']['http_compression']      == TRUE) ? 'checked="checked"' : '';
	$form_cache_email_list       = (@$hosts[$host_id]['settings']['cache_email_list']      == TRUE) ? 'checked="checked"' : '';
	$form_refresh_email_list     = (@$hosts[$host_id]['settings']['refresh_email_list']    == TRUE) ? 'checked="checked"' : '';
	$form_cache_email_folders    = (@$hosts[$host_id]['settings']['cache_email_folders']   == TRUE) ? 'checked="checked"' : '';

	${'form_encrypt_user_data_'.(string)$hosts[$host_id]['settings']['encrypt_user_data']} = 'selected="selected"';
	${'form_mail_send_'.(string)@$hosts[$host_id]['settings']['mail_send']} = 'selected="selected"';

/***************************************
** Template stuff
***************************************/

	$TPL['template'] = 'admin.settings.html';
	include($CONFIG['includes'].'template.wrapper.inc');
?>
