<?php
/***************************************
** Filename.......: admin.tpl.php
** Project name...: Frederick Webmail
** Last Modified..: 03 December 2001
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'admin.hosts.php');

	if($SESSION['login']['admin_status'] !== TRUE){
		fred::redirect('index.php', lang('no_admin_rights'));
	}

/***************************************
** Remove any error message from the
** session and set the error_msg var for
** the template.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Check we've been handed a host_id
***************************************/

	if(!isset($SESSION['admin']['host_id']) AND !isset($HPV['host_id']) ){
		fred::redirect('admin.php', lang('no_host_id'));
	}else{
		$host_id = isset($SESSION['admin']['host_id']) ? (int)$SESSION['admin']['host_id'] : (int)$HPV['host_id'];
	}

/***************************************
** Ordering function
***************************************/

	function tpl_order($a, $b){
		return strcmp($a['label'], $b['label']);
	}

/***************************************
** Submit button hit...
***************************************/

	if(!empty($HPV) AND @is_array($HPV['tpl_sets'])){

		// Build an array of submitted template sets
		$found_default = FALSE;

		foreach($HPV['tpl_sets'] as $dirname => $label){
			$tpl_sets[] = array('dirname' => $dirname, 'label' => $label);
			if($dirname == $HPV['default'])
				$found_default = TRUE;
		}

		// Check default tpl set is ok
		if(!$found_default){
			fred::redirect('redirect.php?to=admin.tpl.php', lang('invalid_default'));
		}
		
		$SESSION['common']['hostinfo'][$host_id]['settings']['default_tpl_set'] = $HPV['default'];
		$SESSION['common']['hostinfo'][$host_id]['tpls'] = $tpl_sets;

		// Write to hostinfo file
		$result = save_hostinfo();

		fred::redirect('redirect.php?to=admin.tpl.php', $result ? lang('changes_saved') : lang('save_failed'));
	}

/***************************************
** First time in, display template.
***************************************/

	// Get host description
	$host_desc = get_host_desc($host_id);

	// Get available template sets from hostinfo
	foreach($SESSION['common']['hostinfo'][$host_id]['tpls'] as $key => $value){
		$current_tpls[] = $value['dirname'];
	}
	
	// Get current physical template sets
	if($dir = opendir($TPL['path'])){
		while($filename = readdir($dir)){
			if($filename == '.' OR $filename == '..') continue;
			
			$desc_file   = $TPL['path'].$filename.'/description.txt';
			$description = file_exists($desc_file) ? implode('', file($desc_file)) : 'No description file exists';
			$dirname     = $filename;
			$checked     = @in_array($filename, $current_tpls) ? 'CHECKED' : '';
			$selected    = ($filename == $SESSION['common']['hostinfo'][$host_id]['settings']['default_tpl_set']) ? 'SELECTED' : '';

			$template_sets[] = array(
			                         'dirname'  => htmlspecialchars($dirname),
									 'label'    => htmlspecialchars($description),
									 'checked'  => $checked,
									 'selected' => $selected
									 );
		}
		usort($template_sets, 'tpl_order');
	}else{
		$error_msg = lang('template_dir_fail');
	}

	$TPL['template'] = 'admin.tpl.html';
	include($CONFIG['includes'].'template.wrapper.inc');
?>
