<?php
/***************************************
** Filename.......: email.action.php
** Project........: Frederick
** Last Modified..: 13 January 2002
** Copyright......: Richard Heyes 2001
***************************************/

	include('config.php');

/***************************************
** Check login
***************************************/

	auth::check_login('login.php', 'email.list.php');

/***************************************
** Function to generate array of msg_ids
** in correct structure
***************************************/

	function parse_msg_ids($msg_ids){
		for($i=0; $i<count($msg_ids); $i++){
			$id     = substr($msg_ids[$i], 0, $pos = strpos($msg_ids[$i], ':'));
			$folder = substr($msg_ids[$i], $pos + 1);
			$ret[$folder][] = $id;
		}
		
		return $ret;
	}

/***************************************
** Default redirect
***************************************/

	$redirect_to = 'email.list.php';

/***************************************
** This is a nasty horrible hack to enable
** the delete option from email.view.message.php
** to work. Ewww...
***************************************/

	if(!empty($HGV['from']) AND $HGV['from'] == 'view_message'){
		$HPV['msg_ids'] = array($HGV['msg_id'] . ':' . $HGV['mbox']);
		$HPV['action']  = 'delete';
		$next_msg_id    = (int)$HGV['next_msg_id'];
		$prev_msg_id    = (int)$HGV['prev_msg_id'];
		$next_msg_mbox  = $HGV['next_msg_mbox'];
		$prev_msg_mbox  = $HGV['prev_msg_mbox'];

		// Remove the entry from the message_ids index in the session.
		$message_ids_idx = (int)$HGV['message_ids_idx'];
		if(isset($SESSION['email']['message_ids'][$message_ids_idx])){
			unset($SESSION['email']['message_ids'][$message_ids_idx]);
			$SESSION['email']['message_ids'] = array_values($SESSION['email']['message_ids']);
		}

		if(@$USERPREFS['settings']['view_msg_delete'] == 'next' AND $next_msg_id) $redirect_to = 'email.view.message.php?msg_id=' . $next_msg_id . '&mbox=' . $next_msg_mbox;
		if(@$USERPREFS['settings']['view_msg_delete'] == 'prev' AND $prev_msg_id) $redirect_to = 'email.view.message.php?msg_id=' . $prev_msg_id . '&mbox=' . $prev_msg_mbox;
		// If neither of the above are called, default takes precedence from above
	}

/***************************************
** Begin
***************************************/

	if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){

		if(!empty($HPV['msg_ids']) AND is_array($HPV['msg_ids'])){

			// Remove these entries from the cache
			for($i=0; $i<count($HPV['msg_ids']); $i++){
				$mailaccess->cache_remove($HPV['msg_ids'][$i]);
			}

			$_msg_ids = parse_msg_ids($HPV['msg_ids']);

			foreach($_msg_ids as $folder => $msg_ids){

				$mailaccess->reconnect($folder);

				$msg_ids = implode(',', $msg_ids);
				$deleted_folder = !empty($USERPREFS['settings']['deleted_items_folder']) ? $USERPREFS['settings']['deleted_items_folder'] : $SESSION['email']['fold'].'Deleted-items';
	
				switch($HPV['action']){
				
					case 'delete':
						$mailaccess->delete($msg_ids, $message);
						break;

					case 'move':
						if(!$mailaccess->capabilities('folders')){
							$message = lang('ef_no_folders');
							break;
						}
	
						if($folder == $HPV['folder']){
							$message = lang('move_to_same_folder');
							break;
						}
	
						$message = $mailaccess->move_msg($msg_ids, $HPV['folder']) ? NULL : lang('move_failed');
						break;
					
					case 'copy':
						if(!$mailaccess->capabilities('folders')){
							$message = lang('ef_no_folders');
							break;
						}
	
						if($folder == $HPV['folder']){
							$message = lang('move_to_same_folder');
							break;
						}
						$message = $mailaccess->copy_msg($msg_ids, $HPV['folder']) ? NULL : lang('move_failed');
						break;
	
					case 'mark_read':
						if(!$mailaccess->capabilities('folders')){
							$message = lang('ef_no_folders');
							break;
						}
	
						// FIXME message should be in lang.inc
						$message = $mailaccess->setflag($msg_ids, 'read') ? NULL : 'Failed to mark messages read';
						break;
	
					case 'mark_unread':
						if(!$mailaccess->capabilities('folders')){
							$message = lang('ef_no_folders');
							break;
						}
	
						// FIXME message should be in lang.inc
						$message = $mailaccess->setflag($msg_ids, 'unread') ? NULL : 'Failed to mark messages unread';
						break;

					case 'flag':
						if(!$mailaccess->capabilities('folders')){
							$message = lang('ef_no_folders');
							break;
						}
	
						// FIXME message should be in lang.inc
						$message = $mailaccess->setflag($msg_ids, 'flagged') ? NULL : 'Failed to flag message(s)';
						break;

					case 'unflag':
						if(!$mailaccess->capabilities('folders')){
							$message = lang('ef_no_folders');
							break;
						}
	
						// FIXME message should be in lang.inc
						$message = $mailaccess->setflag($msg_ids, 'unflagged') ? NULL : 'Failed to mark message(s) unflagged';
						break;
	
					default:
						// FIXME This should be in lang.inc
						$message = 'Unknown action specified';
						break;
				} // End switch
			} // End foreach

		}else{
			// FIXME This should be in lang.inc
			$message = 'No messages selected';
		}

	}else{
		die(lang('failed_connect'));
	}

/***************************************
** Redirect
***************************************/

	fred::redirect($redirect_to, $message);
?>