<?php
/***************************************
** Filename.......: email.compose.php
** Project name...: Frederick
** Last Modified..: 11 February 2002
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'email.compose.php'.(isset($HGV['to']) ? '?to='.$HGV['to'] : ''));

/***************************************
** Remove any error message from the
** session and set the error_msg var for
** the template.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Get the to: address from the query
** string if present.
***************************************/

	if(!empty($HGV['to'])){
		$SESSION['email_compose']['to'] = $HGV['to'];
	}

/***************************************
** If remove_attachment is set, we just do
** this and return to the page.
***************************************/

	if(isset($HGV['remove_attachment']) AND isset($SESSION['email_compose']['files'][$HGV['remove_attachment']])){
		@unlink($SESSION['email_compose']['files'][$HGV['remove_attachment']]['tmp_name']);
		unset($SESSION['email_compose']['files'][$HGV['remove_attachment']]);

		// Re-sort array
		if(count($SESSION['email_compose']['files']) > 0){
			foreach($SESSION['email_compose']['files'] as $value)
				$tmp_arr[] = $value;
			$SESSION['email_compose']['files'] = $tmp_arr;
		}

		fred::redirect('redirect.php?to=email.compose.php');
	}

/***************************************
** Some functions specific to composing.
***************************************/

	function store_input(){

		global $SESSION, $HPV;

		$SESSION['email_compose']['from']        = $HPV['from'];
		$SESSION['email_compose']['replyto']     = $HPV['replyto'];
		$SESSION['email_compose']['to']          = $HPV['to'];
		$SESSION['email_compose']['cc']          = $HPV['cc'];
		$SESSION['email_compose']['bcc']         = $HPV['bcc'];
		$SESSION['email_compose']['subject']     = $HPV['subject'];
		$SESSION['email_compose']['text']        = $HPV['text'];
		$SESSION['email_compose']['read_rcpt']   = @$HPV['read_rcpt'];
		$SESSION['email_compose']['priority']    = $HPV['priority'];
		$SESSION['email_compose']['sensitivity'] = $HPV['sensitivity'];
	}

	function validate_address($input){

		global $SESSION;

		// If blank, don't bother parsing
		if($input === ''){
			$return[0]->personal = '';
			$return[0]->comment  = array();
			$return[0]->mailbox  = '';
			$return[0]->host     = $SESSION['email']['srvr'];
			return $return;
		}

		$addresses = Mail_RFC822::parseAddressList($input, $SESSION['email']['srvr'], TRUE);
		return (is_array($addresses) AND count($addresses) > 0 AND is_object($addresses[0])) ? $addresses : FALSE;
	}

/***************************************
** Form submitted?
***************************************/

	/***************************************
    ** Attachment upload
    ***************************************/

	if(isset($HPV['action']) AND $HPV['action'] == 'add_attachment'){

		store_input();	

		if(!empty($HPF['attachment']['tmp_name']) AND $HPF['attachment']['tmp_name'] !== 'none'){

			foreach($HPF as $value){
				copy($value['tmp_name'], $tmp_filename = fred::get_tmp_filename());
				chmod($tmp_filename, 0777);
				$SESSION['email_compose']['files'][] = array(
																'tmp_name'  => $tmp_filename,
																'filename'  => $value['name'],
																'size'      => $value['size'],
																'c_type'    => $value['type']
															);
			}

		}elseif(!empty($HPF['attachment']['name'])){
			$SESSION['common']['error_msg'] = lang('file_upload_too_large');
		}

		fred::redirect('redirect.php?to=email.compose.php');

	/***************************************
    ** Canceled.
    ***************************************/

	}elseif(isset($HPV['action']) AND $HPV['action'] == 'cancel'){

		if(!isset($USERPREFS['settings']['compose_cancel']) OR $USERPREFS['settings']['compose_cancel'] == 'email_list'){
			fred::redirect('redirect.php?to=email.list.php');

		}elseif($USERPREFS['settings']['compose_cancel'] == 'index'){
			fred::redirect('redirect.php?to=index.php');
		}

	/***************************************
    ** Save draft *** Not yet implemented ***
    ***************************************/

	}elseif(isset($HPV['action']) AND $HPV['action'] == 'save_draft'){

		if(!isset($USERPREFS['settings']['compose_cancel']) OR $USERPREFS['settings']['compose_cancel'] == 'email_list'){
			fred::redirect('redirect.php?to=email.list.php');

		}elseif($USERPREFS['settings']['compose_cancel'] == 'index'){
			fred::redirect('redirect.php?to=index.php');
		}

	/***************************************
    ** Send message
    ***************************************/	

	}elseif(isset($HPV['action']) AND $HPV['action'] == 'send'){

		$error =  FALSE;
		$tmp   =& $SESSION['email_compose']['errors'];

		if(!input::validate($HPV, 'from', 'noempty,init')){ $error = TRUE; $tmp['from'] = lang('missing_from'); }
		if(!input::validate($HPV, 'to',   'noempty,init')){ $error = TRUE; $tmp['to']   = lang('missing_to'); }
		input::init($HPV, 'replyto,cc,bcc,subject,text');

		store_input();

		/***************************************
        ** Validate email addresses
        ***************************************/

		include_once($CONFIG['includes'].'RFC822.php');

		if(!($from_addresses    = validate_address($HPV['from'])))    { $error = TRUE; $tmp['from']    = lang('from_error');}
		if(!($replyto_addresses = validate_address($HPV['replyto']))) { $error = TRUE; $tmp['replyto'] = lang('replyto_error');}
		if(!($to_addresses      = validate_address($HPV['to'])))      { $error = TRUE; $tmp['to']      = lang('to_error');}
		if(!($cc_addresses      = validate_address($HPV['cc'])))      { $error = TRUE; $tmp['cc']      = lang('cc_error');}
		if(!($bcc_addresses     = validate_address($HPV['bcc'])))     { $error = TRUE; $tmp['bcc']     = lang('bcc_error');}

		unset($tmp);

		/***************************************
        ** No errors? Send tha bugger
        ***************************************/

		if($error === FALSE){

			/***************************************
            ** Include the object scripts, set them
			** up and send them.
            ***************************************/

			include_once($CONFIG['includes'].'class.html.mime.mail.inc');

			if(!isset($HOSTINFO['settings']['mail_send']) OR $HOSTINFO['settings']['mail_send'] == 'smtp'){
				include_once($CONFIG['includes'].'class.smtp.inc');

				$params['host'] = $SESSION['email']['smtp_srvr'];
				$params['port'] = $SESSION['email']['smtp_port'];
				$params['helo'] = $SESSION['email']['smtp_helo'];
				$params['auth'] = $SESSION['email']['smtp_auth'];
				$params['user'] = $SESSION['email']['smtp_user'];
				$params['pass'] = $SESSION['email']['smtp_pass'];
				
		        $smtp =& smtp::connect($params);
				if($smtp->status !== SMTP_STATUS_CONNECTED){
					fred::redirect('redirect.php?to=email.compose.php', lang('failed_smtp_connect'));
				}
			}

			$mail =  new html_mime_mail(array('X-Mailer: '.$CONFIG['app_name'].' '.$CONFIG['app_ver'].' ( http://www.v-webmail.co.uk/ )'));

			/***************************************
	        ** Sort out the email addresses, headers
			** etc.
	        ***************************************/

			// This function sorts out actual addresses from Mail_RFC822 output
			function get_addresses($input){

				$addresses = array();

				foreach($input as $value){
					if(is_object($value)){
						if(isset($value->groupname)){
							$addresses = array_merge($addresses, get_addresses($value->addresses));
						}else{
							$addresses[] = $value->mailbox . '@' . $value->host;
						}
					}
				}

				return $addresses;
			}


            // Do we need a Sender: header?
			$_from_addresses = get_addresses($from_addresses);
			if(count($_from_addresses) > 1)
				$headers['Sender'] = $_from_addresses[0];

            // Add the headers
			$headers['Date'] = date('r');
			$headers['From'] = $HPV['from'];
			$headers['To']   = $HPV['to'];
			if(!empty($HPV['cc'])){
				$headers['Cc'] = $HPV['cc'];
			}
			$headers['Subject'] = $HPV['subject'];

			// Reply-To header?
			if(!empty($HPV['replyto'])){
				$headers['Reply-To'] = $HPV['replyto'];
			}

			if(!empty($SESSION['email_compose']['headers'])){
				$headers = array_merge($headers, $SESSION['email_compose']['headers']);
			}

			// Priority header
			switch(@$SESSION['email_compose']['priority']){
				case 'low':
					$headers['Importance'] = 'Low';
					$headers['X-Priority'] = '5 (Lowest)';
					break;

				case 'high':
					$headers['Importance'] = 'High';
					$headers['X-Priority'] = '1 (Highest)';
					break;
			}

			// Sensitivity header
			switch(@$SESSION['email_compose']['sensitivity']){
				case 'personal':
					$headers['Sensitivity'] = 'Personal';
					break;

				case 'private':
					$headers['Sensitivity'] = 'Private';
					break;

				case 'confidential':
					$headers['Sensitivity'] = 'Company-Confidential';
					break;
			}

			// Disposition notification header
			if(!empty($SESSION['email_compose']['read_rcpt'])){
				$headers['Disposition-Notification-To'] = (!empty($SESSION['email_compose']['replyto']) ? $SESSION['email_compose']['replyto'] : $SESSION['email_compose']['from']);
			}

			// Username/server header
			if(@$HOSTINFO['settings']['add_username_server']){
				$headers['X-V-webmail-Auth'] = $SESSION['email']['user'].'@'.$SESSION['email']['srvr'];
			}

            // Add any attachments
			if(isset($SESSION['email_compose']['files'])){
				foreach($SESSION['email_compose']['files'] as $value){
					$mail->add_attachment($mail->get_file($value['tmp_name']), $value['filename'], $value['c_type'], (isset($value['encoding']) ? $value['encoding'] : 'base64'));
				}
			}

            // Build and send it
			$mail->add_text(wordwrap($SESSION['email_compose']['text'], $USERPREFS['settings']['outgoing_wrap'], "\r\n"));

			/***************************************
            ** Plugin for extra headers
            ***************************************/

			call_plugins('email_compose_pre_build');


			$build_params['text_charset'] = lang('default_charset');
			// FIXME This line below needs fixing
			if(!$mail->build_message($build_params))
				; // Do somthing?

			/***************************************
            ** SMTP
            ***************************************/

			if(!isset($HOSTINFO['settings']['mail_send']) OR $HOSTINFO['settings']['mail_send'] == 'smtp'){
    	        // Get the RCPT TO: addresses
				$_to_addresses = get_addresses($to_addresses);

				if($SESSION['email_compose']['cc']  != '') $_to_addresses = array_merge($_to_addresses, get_addresses($cc_addresses));
				if($SESSION['email_compose']['bcc'] != '') $_to_addresses = array_merge($_to_addresses, get_addresses($bcc_addresses));

				foreach($headers as $header_name => $header_value){
					$_headers[] = $header_name.': '.$header_value;
				}

				$send_params['from']       = $_from_addresses[0];
				$send_params['recipients'] = $_to_addresses;
				$send_params['headers']    = $_headers;
				$mail_sent = $mail->smtp_send($smtp, $send_params);

			/***************************************
            ** Regular use of mail() function
			** *** Argh! no abstraction! ***
            ***************************************/

			}elseif($HOSTINFO['settings']['mail_send'] == 'mail'){

				foreach($headers as $header_name => $header_value){
					if(in_array($header_name, array('Subject', 'To', 'Cc'))){
						continue;
					}
					$_headers[] = $header_name.': '.$header_value;
				}

				// Merge headers with mime object headers
				$_headers = array_merge($mail->headers, $_headers);

				// Send
				$mail_sent = $mailaccess->send($SESSION['email_compose']['to'],
				                               $SESSION['email_compose']['subject'],
				                               $mail->output,
				                               implode("\r\n", $_headers),
				                               $SESSION['email_compose']['cc'],
				                               $SESSION['email_compose']['bcc']);

			/***************************************
            ** Something's fubar
            ***************************************/

			}else{
				$mail_sent = FALSE;
			}

			/***************************************
            ** Append message to mailbox
            ***************************************/

			if($mailaccess->capabilities('folders')){
				if(isset($_headers)){
					unset($_headers);
				}
				foreach($headers as $header_name => $header_value){
					$_headers[] = $header_name.': '.$header_value;
				}
				$message = implode("\r\n", array_merge($mail->headers, $_headers))."\r\n\r\n".$mail->output;

				if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){
					$mailaccess->append($message);
				}
			}

			/***************************************
            ** Redirect
            ***************************************/

			if($mail_sent){
				if(!empty($USERPREFS['settings']['compose_send']) AND $USERPREFS['settings']['compose_send'] == 'index'){
					$page = 'index.php';
				}else{
					$page = 'email.list.php';
				}
				fred::redirect('redirect.php?to='.$page, lang('mail_sent'));

			}else{
				fred::redirect('redirect.php?to=email.compose.php', lang('mail_not_sent'));
			}

		/***************************************
        ** An error occurred, redirect to ourself
        ***************************************/

		}else{
			fred::redirect('redirect.php?to=email.compose.php');
		}

	}


/***************************************
** Template stuff.
***************************************/

	/***************************************
    ** Read all addressbook entries
    ***************************************/

	include_once($CONFIG['includes'].'class.prefs.inc');
	$prefs =& prefs::factory($CONFIG['info_storage'], $CONFIG['info_storage_params']);
	$addressbook =& $prefs->read($SESSION['login']['username'].'@'.$SESSION['email']['srvr'].'.addressbook', TRUE, 'addressbook');
	if(!empty($addressbook)){
		foreach($addressbook as $value){
			$name = array();
			if(isset($value['forename'])) $name[] = $value['forename'];
			if(isset($value['surname']))  $name[] = $value['surname'];
	
			$address['email'] = !empty($name) ? '"'.implode(' ', $name).'" <'.$value['email'].'>' : $value['email'];
			$address['name']  = !empty($name) ? implode(' ', $name) : $value['email'];

			$addresses[] = input::htmlspecialchars($address);
		}
	}

	// Build an email address from the userprefs info
	if(!empty($USERPREFS['settings']['email_address'])){
		$name          = !empty($USERPREFS['settings']['name']) ? '"'.$USERPREFS['settings']['name'].'" ' : '';
		$email_address = $name.'<'.$USERPREFS['settings']['email_address'].'>';
	}

	// Build an email address from the userprefs info
	if(!empty($USERPREFS['settings']['reply_address'])){
		$reply_address = $USERPREFS['settings']['email_address'];
	}

	/***************************************
    ** Get existing data from session
    ***************************************/

	$from      = isset($SESSION['email_compose']['from'])       ? htmlspecialchars($SESSION['email_compose']['from'])    : (isset($email_address) ? htmlspecialchars($email_address) : '');
	$replyto   = isset($SESSION['email_compose']['replyto'])    ? htmlspecialchars($SESSION['email_compose']['replyto']) : (isset($reply_address) ? htmlspecialchars($reply_address) : '');
	$to        = isset($SESSION['email_compose']['to'])         ? htmlspecialchars($SESSION['email_compose']['to'])      : '';
	$cc        = isset($SESSION['email_compose']['cc'])         ? htmlspecialchars($SESSION['email_compose']['cc'])      : '';
	$bcc       = isset($SESSION['email_compose']['bcc'])        ? htmlspecialchars($SESSION['email_compose']['bcc'])     : '';
	$subject   = isset($SESSION['email_compose']['subject'])    ? htmlspecialchars($SESSION['email_compose']['subject']) : '';
	$text      = isset($SESSION['email_compose']['text'])       ? htmlspecialchars($SESSION['email_compose']['text'])    : '';
	$read_rcpt = @$SESSION['email_compose']['read_rcpt'] == '1' ? 'CHECKED' : '';

	isset($SESSION['email_compose']['priority'])    ? ${'priority_'.strtolower($SESSION['email_compose']['priority'])} = 'SELECTED' : $priority_normal = 'SELECTED';
	isset($SESSION['email_compose']['sensitivity']) ? ${'sens_'.strtolower($SESSION['email_compose']['sensitivity'])}  = 'SELECTED' : $sens_normal = 'SELECTED';

	/***************************************
    ** Has signature been appended?
    ***************************************/

	if(!@$SESSION['email_compose']['signature_appended']){
		$text .= $USERPREFS['settings']['signature'];
		$SESSION['email_compose']['text'] = @$SESSION['email_compose']['text'] . $USERPREFS['settings']['signature'];
		$SESSION['email_compose']['signature_appended'] = TRUE;
	}

	/***************************************
    ** Get errors from session
    ***************************************/

	if(isset($SESSION['email_compose']['errors'])){

		$tmp =& $SESSION['email_compose']['errors'];
		$from_error    = isset($tmp['from'])    ? htmlspecialchars($tmp['from'])    : '';
		$replyto_error = isset($tmp['replyto']) ? htmlspecialchars($tmp['replyto']) : '';
		$to_error      = isset($tmp['to'])      ? htmlspecialchars($tmp['to'])      : '';
		$cc_error      = isset($tmp['cc'])      ? htmlspecialchars($tmp['cc'])      : '';
		$bcc_error     = isset($tmp['bcc'])     ? htmlspecialchars($tmp['bcc'])     : '';

		unset($tmp);
		unset($SESSION['email_compose']['errors']);
	}

	/***************************************
    ** Sort out any attachments
    ***************************************/

	if(isset($SESSION['email_compose']['files'])){
		for($i=0; $i<count($SESSION['email_compose']['files']); $i++){

			if(isset($SESSION['email_compose']['files'][$i])){

				$attachments[] = array_merge($SESSION['email_compose']['files'][$i], array('id' => $i));
				// Format the size
				if($attachments[count($attachments)-1]['size'] > 1048576)
					$attachments[count($attachments)-1]['size'] = number_format(($attachments[count($attachments)-1]['size'] / 1048576), 2).' Mb';
	
				elseif($attachments[count($attachments)-1]['size'] > 1024)
					$attachments[count($attachments)-1]['size'] = number_format(($attachments[count($attachments)-1]['size'] / 1024), 2).' Kb';
	
				else
					$attachments[count($attachments)-1]['size'] = $attachments[count($attachments)-1]['size'].' bytes';
			}
		}
	}

/***************************************
** Signature for add sig button
***************************************/

	$tpl_signature = str_replace("\r", "\\r", $USERPREFS['settings']['signature']);
	$tpl_signature = str_replace("\n", "\\n", $tpl_signature);
	$tpl_signature = str_replace("'", "\\'", $tpl_signature);

/***************************************
** Get account info
***************************************/

	$TPL['template'] = 'email.compose.html';
	include($CONFIG['includes'].'template.wrapper.inc');

?>
