<?php
/***************************************
** Filename.......: email.folders.php
** Project........: Frederick
** Last Modified..: 15 December 2001
** Copyright......: Richard Heyes 2001
***************************************/

	include('config.php');

/***************************************
** Logged in?
***************************************/

	auth::check_login('login.php', 'email.folders.php');

/***************************************
** Remove any error message from the
** session and set the error_msg var for
** the template.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Connect to retreive folder list
***************************************/

	if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){

		if($mailaccess->capabilities('folders')){

			switch(@$HPV['action']){

				case 'create':
					if(!empty($HPV['create_folder_name'])){
						$mailaccess->create_folder($SESSION['email']['fold'].$HPV['create_folder_name']);
						if(@$USERPREFS['settings']['auto_subscribe_new']){
							$mailaccess->subscribe_folder($SESSION['email']['fold'].$HPV['create_folder_name']);
						}
					}
					fred::redirect('redirect.php?to=email.folders.php');
					break;

				case 'delete':
					if(!empty($HPV['delete_folder']) AND $HPV['delete_folder'] != 'INBOX'){
						$mailaccess->unsubscribe_folder($HPV['delete_folder']);
						$result = $mailaccess->delete_folder($HPV['delete_folder']);
						// FIXME - message belongs in lang.inc
						$message = $result ? NULL : 'Failed to delete folder';
					}else{
						$message = NULL;
					}
					fred::redirect('redirect.php?to=email.folders.php', $message);
					break;

				case 'rename':
					if(!empty($HPV['rename_folder_from']) AND !empty($HPV['rename_folder_to']) AND $HPV['rename_folder_to'] != 'INBOX'){
						$result = $mailaccess->rename_folder($HPV['rename_folder_from'], $SESSION['email']['fold'].$HPV['rename_folder_to']);
						$mailaccess->unsubscribe_folder($HPV['rename_folder_from']);
						// FIXME - message belongs in lang.inc
						$message = $result ? NULL : 'Failed to rename mailbox';
					}else{
						$message = NULL;
					}
					fred::redirect('redirect.php?to=email.folders.php', $message);
					break;

				case 'save':

					// Unsubscribe from all folders
					$all_folders = $mailaccess->get_all_folders();
					foreach($all_folders as $folder){
						if($folder['noselect'] != TRUE){
							$mailaccess->unsubscribe_folder($folder['name']);
						}
					}

					// Subscribe to selected folders
					if(isset($HPV['subs_folders']) AND is_array($HPV['subs_folders'])){
						foreach($HPV['subs_folders'] as $folder){
							$mailaccess->subscribe_folder($folder);
						}
					}
					fred::redirect('redirect.php?to=email.folders.php');
					break;

				default:
					$mailaccess->check_key_folders();
		
					$subscribed_folders = $mailaccess->get_subscribed_folders();
					$all_folders = $mailaccess->get_all_folders(TRUE);

					// Create list of subscribed folders usable with in_array()
					$subscribed_folders_flat = array();
					foreach($subscribed_folders as $value){
						if($value['noselect'] != TRUE){
							$subscribed_folders_flat[] = $value['name'];
						}
					}

					// Create the subs_folders array
					for($i=0; $i<count($all_folders); $i++){
						unset($arr);

						// Subs array
						$arr = $all_folders[$i];
						$arr['checked']  = in_array($all_folders[$i]['name'], $subscribed_folders_flat) ? 'checked' : '';
						if($all_folders[$i]['noselect'] === TRUE){
							$arr['image']    = '<img src="images/default/folder-icon.gif">';
							$arr['input']    = '';
							$arr['size']     = '';
							$arr['link']     = $arr['text'];
						}else{
							$arr['image']         = '';
							$arr['input']         = '<input type="checkbox" name="subs_folders[]" value="'.$arr['name_htmlsafe'].'" id="'.$arr['name_htmlsafe'].'" '.$arr['checked'].'>';
							$arr['link']          = '<a href="email.list.php?mbox=' . $arr['name_urlsafe'] . '&sm=1" style="text-decoration: none">' . $arr['text'] . '</A>';
							$arr['messages']      = $all_folders[$i]['messages'];
							$arr['unseen']        = $all_folders[$i]['unseen'];
							$arr['size']          = $all_folders[$i]['size'];
						}

						$arr['rename_prompt'] = str_replace($SESSION['email']['fold'], '', $arr['name']);

						$subs_folders[] = $arr;
					}
			} //End switch
		}else{
			fred::redirect('index.php', lang('ef_no_folders'));
		}

	/***************************************
    ** Connect() failed
    ***************************************/

	}else{
		die(lang('failed_connect'));
	}

/***************************************
** Template stuff
***************************************/

	$TPL['template'] = 'email.folders.html';
	include($CONFIG['includes'].'template.wrapper.inc');

?>