<?php
/***************************************
** Filename.......: email.list.inc
** Project name...: Frederick
** Last Modified..: 10 November 2001
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'email.list.php');

/***************************************
** Get the order_by and ascdesc variables
** either from the query string or session
** or defaults.
***************************************/

	if(isset($HGV['order_by'])){
		$SESSION['email']['order_by'] = $HGV['order_by'];
		$order_by = $HGV['order_by'];

	}elseif(isset($SESSION['email']['order_by'])){
		$order_by = $SESSION['email']['order_by'];

	}else{
		$SESSION['email']['order_by'] = 'arrival';
		$order_by = 'arrival';
	}

	if(isset($HGV['ascdesc'])){
		$SESSION['email']['ascdesc'] = $HGV['ascdesc'];
		$ascdesc = $HGV['ascdesc'];

	}elseif(isset($SESSION['email']['ascdesc'])){
		$ascdesc = $SESSION['email']['ascdesc'];

	}else{
		$SESSION['email']['ascdesc'] = 1;
		$ascdesc = 1;
	}
	
/***************************************
** If the start point is to be altered
** then set that up.
***************************************/

	if(isset($HGV['sm'])){
		$SESSION['email']['start_msg'] =& $HGV['sm'];
		if((int)$SESSION['email']['start_msg'] < 1)
			$SESSION['email']['start_msg'] = 1;
	}

/***************************************
** Change of folder?
***************************************/

	if(isset($HGV['mbox']) AND !empty($HGV['mbox'])){
		$SESSION['email']['mbox'] = $HGV['mbox'];
		$SESSION['email']['start_msg'] = 1;
		if(isset($SESSION['search'])){
			unset($SESSION['search']);
		}
	}

/***************************************
** Remove any error message from the
** session and set the error_msg var for
** the template.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Read the session variables if we need to.
***************************************/

	if(isset($SESSION['email']['start_msg'])) $start_msg = $SESSION['email']['start_msg'];

	if(!isset($show_per_page)) $show_per_page = max($USERPREFS['settings']['show_per_page'], 5);
	if(!isset($start_msg))     $start_msg     = 1;

	$SESSION['email']['start_msg'] = $start_msg;


/***************************************
** If we're supposed to clear the cache,
** do that and redirect back to the list
***************************************/

	if(!empty($HGV['clear_cache'])){
		$mailaccess->cache_clear();
		fred::redirect('redirect.php?to=email.list.php');
	}

/***************************************
** List the current mailbox or search ?
***************************************/

	if(!empty($SESSION['search'])){
		include($CONFIG['includes'] . 'email.list.search.inc');
	}else{
		include($CONFIG['includes'] . 'email.list.normal.inc');
	}


	
/***************************************
** Template stuff. Sets up variables and
** calls the tpl engine.
***************************************/

	/***************************************
    ** Autorefresh?
    ***************************************/

	if(!isset($SESSION['search']) AND @$USERPREFS['settings']['autorefresh_list'] > 0){
		header('Refresh: ' . $USERPREFS['settings']['autorefresh_list']);
	}

	/***************************************
	** Back and next links and Message numbers
	** that appear at top.
	***************************************/

	$msg_start_num = $start_msg;
	$msg_end_num   =  min($start_msg + $show_per_page -  1, $num_msgs);
	$total_msgs    = $num_msgs;

	if($msg_end_num < $total_msgs){
		$next_link = '<A HREF="email.list.php?sm='.($start_msg+$show_per_page).'">'.lang('next_link').'</A>';
	}else{
		$next_link = '';
	}

	if($msg_start_num > 1 AND $num_msgs > 0){
		$sm = max($msg_start_num - $show_per_page, 1);
		$back_link = '<A HREF="email.list.php?sm='.$sm.'">'.lang('back_link').' </A>';
	}else{
		$back_link = '';
	}

	/***************************************
	** If there are no messages, reset the
	** start number.
	***************************************/

	if($num_msgs == 0){
		$msg_start_num = 0;
	}

/***************************************
** Some template stuff
***************************************/

	$TPL['template'] = 'email.list.html';
	include($CONFIG['includes'].'template.wrapper.inc');
?>
