<?php
/***************************************
** Filename.......: email.search.php
** Project........: Frederick
** Last Modified..: $Date: 2002/03/07 12:49:18 $
** CVS Revision...: $Revision: 1.3 $
** Copyright......: 2001, 2002 Richard Heyes
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'email.search.php');

/***************************************
** Form submitted?
***************************************/
	
	$received_on     = FALSE;
	$received_before = FALSE;
	$received_since  = FALSE;

	if(!empty($HPV)){

		if(!empty($HPV['from']))    $criteria[] = 'from';
		if(!empty($HPV['to']))      $criteria[] = 'to';
		if(!empty($HPV['cc']))      $criteria[] = 'cc';
		if(!empty($HPV['subject'])) $criteria[] = 'subject';
		if(!empty($HPV['body']))    $criteria[] = 'body';

		if(!empty($HPV['received_on_year']) OR !empty($HPV['received_on_month']) OR !empty($HPV['received_on_day'])) $received_on = TRUE;
		if(!empty($HPV['received_on_year']) OR !empty($HPV['received_on_month']) OR !empty($HPV['received_on_day'])) $received_on = TRUE;
		if(!empty($HPV['received_on_year']) OR !empty($HPV['received_on_month']) OR !empty($HPV['received_on_day'])) $received_on = TRUE;
		if($received_on) $criteria[] = 'received_on';

		if(!empty($HPV['received_before_year']) OR !empty($HPV['received_before_month']) OR !empty($HPV['received_before_day'])) $received_before = TRUE;
		if(!empty($HPV['received_before_year']) OR !empty($HPV['received_before_month']) OR !empty($HPV['received_before_day'])) $received_before = TRUE;
		if(!empty($HPV['received_before_year']) OR !empty($HPV['received_before_month']) OR !empty($HPV['received_before_day'])) $received_before = TRUE;
		if($received_before) $criteria[] = 'received_before';

		if(!empty($HPV['received_since_year']) OR !empty($HPV['received_since_month']) OR !empty($HPV['received_since_day'])) $received_since = TRUE;
		if(!empty($HPV['received_since_year']) OR !empty($HPV['received_since_month']) OR !empty($HPV['received_since_day'])) $received_since = TRUE;
		if(!empty($HPV['received_since_year']) OR !empty($HPV['received_since_month']) OR !empty($HPV['received_since_day'])) $received_since = TRUE;
		if($received_since) $criteria[] = 'received_since';

		if(!empty($HPV['folders'])) $folders = $HPV['folders']; else $folders[] = 'INBOX';
// Potential OR code:
//		if(!empty($HPV['match']))   $match = ($HPV['match'] == 'any' ? 'any' : 'all'); else $match = 'all';

		/***************************************
        ** Finished checking input, build search string
        ***************************************/
		
		for($i=0; $i<count(@$criteria); $i++){
			switch($criteria[$i]){
				case 'from':
				case 'to':
				case 'cc':
				case 'subject':
				case 'body':
					$string = strtr($HPV[$criteria[$i]], array('"' => '\"', '\\' => '\\\\'));
					$search_string[] = strtoupper($criteria[$i]) . ' "' . $string . '"';
					break;

				case 'received_on':
				case 'received_before':
				case 'received_since':
					$keyword = substr($criteria[$i], strrpos($criteria[$i], '_') + 1);
					$year  = !empty($HPV['received_' . $keyword . '_year'])  ? $HPV['received_' . $keyword . '_year'] : date('Y');
					$month = !empty($HPV['received_' . $keyword . '_month']) ? date('M', mktime(0,0,0,$HPV['received_' . $keyword . '_month'],1,date('Y'))) : date('M');
					$date  = !empty($HPV['received_' . $keyword . '_day'])  ? $HPV['received_' . $keyword . '_day'] : '1';

					$search_string[] = strtoupper($keyword) . ' ' . $date . '-' . $month . '-' . $year;
					break;
			}
		}

		/***************************************
        ** Generate and store the full search string
		** ORing requires a little magic as you can
		** only OR two search strings at once. Eg.
		** Three strings ORed would require:
		** OR (OR <search-string1> <search-string2>) <search-string2>
		**
		** *** IMAP extension doesn't support OR... ***
		**
        ***************************************/
// Potential OR code
/*
		if($match == 'all'){
			$SESSION['search']['string']   = 'ALL ' . implode(' ', $search_string);
		}else{
			while(count($search_string) > 1){
				$tmp_search_string = $search_string;
				$search_string = array();

				for($i=0; $i<count($tmp_search_string); $i++){
					if($i % 2 > 0){
						$search_string[] = 'OR ' .
						                   (preg_match('/^OR /', $tmp) ? '(' . $tmp . ')' : $tmp) .
										   ' '   .
										   (preg_match('/^OR /', $tmp_search_string[$i]) ? '(' . $tmp_search_string[$i] . ')' : $tmp_search_string[$i]);
						unset($tmp);
					}else{
						$tmp = $tmp_search_string[$i];
					}
				}
				if(!empty($tmp)){
					$search_string[] = $tmp;
				}
			}
			
			$SESSION['search']['string'] = $search_string[0];
		}
*/
		$SESSION['search']['string']   = implode(' ', $search_string);
		$SESSION['search']['folders']  = $folders;
		$SESSION['email']['start_msg'] = 1;

		/***************************************
        ** Redirect
        ***************************************/

		fred::redirect('email.list.php?sm=1');
	}

/***************************************
** Form not submitted...
***************************************/

	if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){

		if($mailaccess->capabilities('folders')){
			$mailaccess->check_key_folders();
	
			$folders = $mailaccess->get_subscribed_folders();
			for($i=0; $i<count($folders); $i++){
				if('INBOX' == $folders[$i]['name']){
					$folders[$i]['selected'] = 'selected';
				}else{
					$folders[$i]['selected'] = '';
				}
			}
		}
	}

/***************************************
** Template
***************************************/

	$date_select = range(1, 31);
	for($i=0; $i<count($date_select); NULL){
		$date_select[$i] = array('date' => ++$i, 'selected' => '');
	}
	array_unshift($date_select, array('date' => ''));

	$TPL['template'] = 'email.search.html';
	include($CONFIG['includes'] . 'template.wrapper.inc');
?>