<?php
/***************************************
** Filename.......: email.view.message.php
** Project name...: Frederick
** Last Modified..: 25 November 2001
***************************************/

	include('config.php');

/***************************************
** Check Login
***************************************/

	auth::check_login('login.php', 'email.list.php');

/***************************************
** Check for message id.
***************************************/

	if(!isset($HGV['msg_id']) OR $HGV['msg_id'] < 1){
		fred::redirect('email.list.php', lang('no_msg_id_passed'));
	}

/***************************************
** Check for mbox
***************************************/

	if(!empty($HGV['mbox'])){
		$SESSION['email']['mbox'] = $HGV['mbox'];
	}

/***************************************
** Function makes links out of from/to/cc/bcc
** headers.
***************************************/

	function parse_header_recipients($data){
		global $CONFIG, $SESSION;
		include_once($CONFIG['includes'] . 'RFC822.php');

		foreach(Mail_RFC822::parseAddressList($data, null, null, FALSE) as $email){

			$personal = !empty($email->personal) ? $email->personal . ' <%s>' : '%s';
			$mailbox  = !empty($email->host) ? $email->mailbox . '@' . $email->host : $email->mailbox;

			$tmp = sprintf($personal, $mailbox);
			$links[] = sprintf('<a href="email.compose.php?to=%s">%s</a> <a href="addressbook.list.php?add_address=%s">%s</a>', urlencode($tmp), htmlspecialchars($tmp), urlencode($tmp), lang('contact_gif'));
		}

		return implode(', ', $links);
	}

/***************************************
** Remove cached summary information
***************************************/

	$mailaccess->cache_remove($HGV['msg_id'] . ':' . $SESSION['email']['mbox']);

/***************************************
** Determine if we're supposed to be showing
** an attached message.
***************************************/

	if(isset($HGV['attached'])){
		if(!isset($HGV['encoding']))	$error = TRUE;
		if(!isset($HGV['msg_id']))		$error = TRUE;
		if(!isset($HGV['part_id']))		$error = TRUE;
	
		if(@$error === TRUE){
			die('Incorrect arguments passed');
		}

		$attached_msg	= TRUE;
		$partno			= $HGV['part_id'];
		$msg_id			= $HGV['msg_id'];
		$encoding		= $HGV['encoding'];

	}else{

		$attached_msg	= FALSE;
		$partno			= NULL;
		$msg_id			= $HGV['msg_id'];
		$encoding		= NULL;
	}

/***************************************
** Get details of the message.
***************************************/

	if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){

		/***************************************
        ** Check the message exists
        ***************************************/

		if(!@$mailaccess->headerinfo($msg_id)){
			fred::redirect('email.list.php', lang('no_such_msg'));
		}

		/***************************************
        ** Decode the email
        ***************************************/

		include($CONFIG['includes'].'mimeDecode.php');
		$email  = $mailaccess->get_raw_headers($msg_id, $partno);
		$email .= $mailaccess->get_body($msg_id, $partno, TRUE);

		$email  = preg_replace("/\r?\n/", "\r\n", $email);
		$params = array(
						'input'          => $email,
						'crlf'           => "\r\n",
						'include_bodies' => TRUE,
						'decode_headers' => TRUE,
						'decode_bodies'  => TRUE
						);
	
		$structure = Mail_mimeDecode::decode($params);
		if(isset($HGV['show_all_headers']) AND $HGV['show_all_headers'] == 1){

			/***************************************
    	    ** Show all headers
	        ***************************************/

			foreach($structure->headers as $header_name => $header_value){
				$name = str_replace('-', ' ', $header_name);
				$name = ucwords($name);
				$name = str_replace(' ', '-', $name);

				$header_value = (array)$header_value;
				for($i=0; $i<count($header_value); $i++){
					$headers[] = array('name' => lang(strtolower($name)) != '' ? lang(strtolower($name)) : $name,
									   'data' => htmlspecialchars(decode_header($header_value[$i]))
									  );
				}
			}

		}else{

			/***************************************
			** Show normal headers
			***************************************/

			foreach(array('Date', 'From', 'To', 'Cc', 'Subject', 'Importance', 'Sensitivity') as $header_name){
				if(isset($structure->headers[strtolower($header_name)])){
					if('Sensitivity' == $header_name){
						$tpl_sensitive = TRUE;
					}

					if('Importance' == $header_name AND 'normal' == strtolower($structure->headers[strtolower($header_name)])){
						continue;
					}

					if(is_array($structure->headers[strtolower($header_name)])){
						$structure->headers[strtolower($header_name)] = implode(', ', $structure->headers[strtolower($header_name)]);
					}

					$header_value = decode_header($structure->headers[strtolower($header_name)]);
					if(in_array(strtolower($header_name), array('to', 'cc', 'from'))){
						$header_value = parse_header_recipients($header_value);
					}else{
						$header_value = htmlspecialchars($header_value);
					}
					$headers[] = array('name' => lang(strtolower($header_name)) ? lang(strtolower($header_name)) : $header_name, 'data' => $header_value);
				}
			}
		}

		/***************************************
        ** List headers ?
        ***************************************/

		// List-Post		
		if(!empty($structure->headers['list-post']) AND preg_match('/<mailto:(.*)>/Ui', $structure->headers['list-post'])){
			$tpl_list_reply = TRUE;
		}

		// List-Unsubscribe
		if(!empty($structure->headers['list-unsubscribe']) AND preg_match('/<mailto:(.*)>/Ui', $structure->headers['list-unsubscribe'])){
			$tpl_list_reply_mailto = TRUE;
		}elseif(!empty($structure->headers['list-unsubscribe']) AND preg_match('/<http:\/\/(.*)>/Ui', $structure->headers['list-unsubscribe'], $matches)){
			$tpl_list_reply_http      = TRUE;
			$tpl_list_reply_http_link = 'http://' . $matches[1];
		}


		/***************************************
        ** Populate the $msg_struct from $structure
        ***************************************/

		$msg_struct = new message();
		get_msg($structure, $HGV['msg_id'], (isset($partno) ? $partno : 1) , FALSE, FALSE);

		/***************************************
		** If there is html present then check
		** for any related items and process
		** accordingly.
		***************************************/

		if(@$HOSTINFO['settings']['allow_html_email'] AND $USERPREFS['settings']['show_html'] == TRUE AND !empty($msg_struct->body_html)){

			if(count($msg_struct->related) > 0){

				// Replace the cid:'s with a link to email.view.related.php
				for($i=0; $i<count($msg_struct->related); $i++){

					if(substr($msg_struct->related[$i]['c_id'],0,1) == '<' AND substr($msg_struct->related[$i]['c_id'],-1) == '>')
						$msg_struct->related[$i]['c_id'] = substr($msg_struct->related[$i]['c_id'],1,-1);

						$msg_struct->body_html = str_replace('cid:'.$msg_struct->related[$i]['c_id'], $CONFIG['web_path'].'email.view.related.php?encoding='.$msg_struct->related[$i]['encoding'].'&msg_id='.$msg_struct->related[$i]['msg_id'].'&part_id='.$msg_struct->related[$i]['part_id'].'&c_type='.urlencode($msg_struct->related[$i]['c_type']).'&size='.$msg_struct->related[$i]['size'], $msg_struct->body_html);
				}
			}

			// Find the body tag, take the attributes from it and then remove it.
			if(preg_match('/<body([^>]*)>/i', $msg_struct->body_html, $matches)){

				$attributes = implode(' ', preg_split('/\s+/', trim($matches[1])));

				// Check for external background images
				if($HOSTINFO['settings']['remove_external_images'] AND preg_match('/background="?(?:http|ftp):\/\//i', $attributes)){
					$attributes = preg_replace('/background="?[^\s]+/si', '', $attributes);
				}

				// Check for background color attribute
				if(strpos(strtolower($attributes), 'bgcolor=') !== FALSE)
					$bgcolor = '';

				$start_pos = strpos($msg_struct->body_html, $matches[0])+strlen($matches[0]);
				$end_pos   = strpos(strtolower($msg_struct->body_html), '</body');

				$msg_struct->body_html = substr($msg_struct->body_html,$start_pos, $end_pos-$start_pos);
			}
		}


		/***************************************
		** Determine which to print, html or text.
		***************************************/

		$html = !empty($msg_struct->body_html);
		$text = !empty($msg_struct->body_plain);

		// Both html and plain text are present.
		if($html AND $text){

			// User AND admin settings checked
			if($USERPREFS['settings']['show_html'] == TRUE AND @$HOSTINFO['settings']['allow_html_email']){
				$body		 = wordwrap($msg_struct->body_html, 80, "\r\n");
				$tpl_charset = $msg_struct->html_charset;
				call_plugins('view_message_html_output');
			}else{
				$body		 = wordwrap($msg_struct->body_plain, 80, "\r\n");
				$tpl_charset = $msg_struct->text_charset;
				$pre_start	 = '<PRE>';
				$pre_end	 = '</PRE>';
				call_plugins('view_message_text_output');
			}

		// Message is HTML only, still checking admin settings
		}elseif($html AND !$text){
			$body		 = wordwrap($msg_struct->body_html, 80, "\r\n");
			$tpl_charset = $msg_struct->html_charset;
			if( (!$USERPREFS['settings']['show_html'] AND $USERPREFS['settings']['strip_html_tags']) OR @!$HOSTINFO['settings']['allow_html_email']){
				$pre_start = '<PRE>';
				$pre_end   = '</PRE>';
				$body      = strip_tags($body);
				call_plugins('view_message_text_output');
			}else{
				call_plugins('view_message_html_output');
			}

		// Message is plain text only
		}elseif($text AND !$html){

			$body		 = wordwrap($msg_struct->body_plain, 80, "\r\n");
			$tpl_charset = $msg_struct->text_charset;
			$pre_start	 = '<PRE>';
			$pre_end	 = '</PRE>';
			call_plugins('view_message_text_output');

		// Message is screwed?
		}else{
			$body = '&nbsp;';
		}
		
		if(trim($body) == ''){
			$body = '&nbsp;';
		}



		/***************************************
		** HANDLE ATTACHMENTS
		***************************************/

		if(count($msg_struct->attachments) > 0){
			foreach($msg_struct->attachments as $attachment){

				/***************************************
				** Filename
				***************************************/

				if(isset($attachment['description']))        $filename = $attachment['description'];
				if(isset($attachment['name']))               $filename = $attachment['name'];
				if(isset($attachment['filename']))           $filename = $attachment['filename'];
				if(!isset($filename) OR $filename == '') $filename = 'Unknown';
				
				/***************************************
				** Filesize.
				***************************************/

				if($attachment['size'] > 1048576){
					$size = round($attachment['size'] / 1048576, 1).'Mb';

				}elseif($attachment['size'] > 1024){
					$size = round($attachment['size'] / 1024, 1).'Kb';

				}else{
					$size = $attachment['size'] . 'b';
				}

				/***************************************
				** Determine links href and onlick attribs
				***************************************/
				// Default download and "view as text" links
				$dl_link   = sprintf('<a href="email.attachment.php?encoding=%s&msg_id=%s&part_id=%s&size=%s&c_type=%s&filename=%s&action=dl">Download</a>',
									 $attachment['encoding'],
									 $attachment['msg_id'],
									 $attachment['part_id'],
									 $attachment['size'],
									 urlencode($attachment['c_type']),
									 urlencode($filename));
				$text_link = sprintf('<a href="#" onclick="window.open(\'email.attachment.php?encoding=%s&msg_id=%s&part_id=%s&size=%s&c_type=%s&filename=%s&action=view\', \'%s\', \'menubar,scrollbars,resizable,width=696,height=500\'); return false">View as text</a>',
									 $attachment['encoding'],
									 $attachment['msg_id'],
									 $attachment['part_id'],
									 $attachment['size'],
									 urlencode('text/plain'),
									 urlencode($filename . '.txt'), // Try to force it to be shown as text
									 md5(microtime()));

				switch(TRUE){
					// Opens using email.view.message.php in a new window
					case $attachment['c_type'] == 'message/rfc822':
						$view_link = sprintf('<a href="#" onclick="window.open(\'email.view.message.php?action=view&attached=1&encoding=%s&msg_id=%s&part_id=%s\', \'%s\', \'menubar,scrollbars,resizable,width=696,height=500\'); return false">View</a>',
											 $attachment['encoding'],
											 $attachment['msg_id'],
											 $attachment['part_id'],
											 md5(microtime()));
						$dl_link   = '';
						break;

					// View link has hard coded text/plain content type
					case $attachment['c_type'] == 'text/rfc822-headers':
					case $attachment['c_type'] == 'message/delivery-status':
					case $attachment['c_type'] == 'message/disposition-notification':
						$view_link = sprintf('<a href="#" onclick="window.open(\'email.attachment.php?encoding=%s&msg_id=%s&part_id=%s&c_type=text/plain&size=%s&filename=%s&action=view\', \'%s\', \'menubar,scrollbars,resizable,width=696,height=500\')">View</a>',
											 $attachment['encoding'],
											 $attachment['msg_id'],
											 $attachment['part_id'],
											 $attachment['size'],
											 urlencode($filename),
											 md5(microtime()));
						break;

					// View link opens in new window
					case substr($attachment['c_type'], 0, 5) == 'image':
					case substr($attachment['c_type'], 0, 4) == 'text':
						$view_link = sprintf('<a href="#" onclick="window.open(\'email.attachment.php?encoding=%s&msg_id=%s&part_id=%s&size=%s&c_type=%s&filename=%s&action=view\', \'%s\', \'menubar,scrollbars,resizable,width=696,height=500\')">View</a>',
											 $attachment['encoding'],
											 $attachment['msg_id'],
											 $attachment['part_id'],
											 $attachment['size'],
											 urlencode($attachment['c_type']),
											 urlencode($filename),
											 md5(microtime()));
						break;

					// Up to the client as to what happens with view link.
					default:
						$view_link = sprintf('<a href="email.attachment.php?encoding=%s&msg_id=%s&part_id=%s&size=%s&c_type=%s&filename=%s&action=view">View</a>',
											 $attachment['encoding'],
											 $attachment['msg_id'],
											 $attachment['part_id'],
											 $attachment['size'],
											 urlencode($attachment['c_type']),
											 urlencode($filename));
						break;
				}

				/***************************************
				** Create data for template subloop
				***************************************/

				$attachments[] = array(
										'filename'	=> $filename,
										'c_type'	=> $attachment['c_type'],
										'text_link' => $text_link,
										'view_link'	=> $view_link,
										'dl_link'	=> $dl_link,
										'size'		=> $size
									  );
			} // End foreach

			$headers[] = array('name'			=> 'Attachments',
							   'data'			=> '',
							   'attachments'	=> $attachments
							  );
		}


/***************************************
** Connection to server failed.
***************************************/

	}else{
		die(lang('failed_connect'));
	}


/***************************************
** This determines the next and previous
** message numbers for the links.
***************************************/

	if(!empty($HGV['message_ids_idx'])){
		$message_ids_idx = $HGV['message_ids_idx'];
	}else{
		for($i=0; $i<count($SESSION['email']['message_ids']); $i++){
			if(!empty($HGV['mbox']) AND $SESSION['email']['message_ids'][$i]['mailbox'] == $HGV['mbox'] AND $SESSION['email']['message_ids'][$i]['msg_id'] == $HGV['msg_id']){
				$message_ids_idx = $i;
				break;
			}elseif($SESSION['email']['message_ids'][$i]['mailbox'] == $SESSION['email']['mbox'] AND $SESSION['email']['message_ids'][$i]['msg_id'] == $HGV['msg_id']){
				$message_ids_idx = $i;
				break;
			}
		}
		if(!isset($message_ids_idx)){
			$message_ids_idx = 0;
		}
	}

	$back_link_message_ids_idx = !empty($SESSION['email']['message_ids'][$message_ids_idx - 1]) ? $message_ids_idx - 1 : '';
	$next_link_message_ids_idx = !empty($SESSION['email']['message_ids'][$message_ids_idx + 1]) ? $message_ids_idx + 1 : '';

	$back_link_msg_id = !empty($SESSION['email']['message_ids'][$message_ids_idx - 1]) ? $SESSION['email']['message_ids'][$message_ids_idx - 1]['msg_id'] : '';
	$next_link_msg_id = !empty($SESSION['email']['message_ids'][$message_ids_idx + 1]) ? $SESSION['email']['message_ids'][$message_ids_idx + 1]['msg_id'] : '';

	$back_link_mbox = !empty($SESSION['email']['message_ids'][$message_ids_idx - 1]) ? urlencode($SESSION['email']['message_ids'][$message_ids_idx - 1]['mailbox']) : '';
	$next_link_mbox = !empty($SESSION['email']['message_ids'][$message_ids_idx + 1]) ? urlencode($SESSION['email']['message_ids'][$message_ids_idx + 1]['mailbox']) : '';

/***************************************
** Template vars
***************************************/

	if(isset($structure->headers['subject'])){
		$tpl_title  = 'Message: '.$structure->headers['subject'];
	}
	$tpl_mbox     = $SESSION['email']['mbox'];
	$tpl_mbox_url = urlencode($SESSION['email']['mbox']);
	$tpl_partno   = $partno;
	$tpl_msg_id   = $msg_id;

	$tpl_all_hdrs = $HVV['REQUEST_URI'].( (!empty($HGV['show_all_headers'])) ? '' : '&show_all_headers=1' );
	$tpl_nor_hdrs = str_replace('&show_all_headers=1', '', $HVV['REQUEST_URI']);

/***************************************
** Template stuff.
***************************************/

	$TPL['template'] = 'email.view.message.html';
	include($CONFIG['includes'].'template.wrapper.inc');
?>
