<?php
/***************************************
** Filename.....: login.php
** Last changed.: 08 January 2002
** Notes........:
***************************************/

	include('config.php');

/***************************************
** Parse servers config file
***************************************/

	// Servers.ini
	$filename = file_exists($CONFIG['conf_dir'] . 'local.servers.php') ? $CONFIG['conf_dir'] . 'local.servers.php' : $CONFIG['conf_dir'] . 'servers.php';
	if(@filemtime($filename) > @filemtime($CONFIG['tmp_dir'] . 'servers.php.tmp') OR @!include_once($CONFIG['tmp_dir'] . 'servers.php.tmp')){
		$conf_file = 'servers.php';
		include($CONFIG['includes'] . 'parse.ini.inc');
	}

/***************************************
** Check Login
***************************************/

	if(auth::is_logged_in()){
		fred::redirect('index.php');
	}

/***************************************
** If form has been posted do this...
***************************************/

	if(!empty($HPV)){

		/***************************************
        ** Check for username and password
        ***************************************/

		$username = isset($HPV['username']) ? $HPV['username'] : '';
		$password = isset($HPV['password']) ? $HPV['password'] : '';

		/***************************************
        ** Check for template option.
        ***************************************/

		$template = isset($HPV['template']) ? $HPV['template'] : $SESSION['common']['default_tpl_set'];

		$template = $HPV['template'];
		if(file_exists($TPL['path'].$template)){
			$SESSION['common']['tpl_set'] = $template;
		}

		/***************************************
        ** Now check the login details.
        ***************************************/

		if($CONFIG['servers_strict'] AND !isset($HPV['server_id'])){
			fred::redirect('redirect.php?to=login.php', lang('no_server_id'));

		}elseif($CONFIG['servers_strict'] AND !isset($SERVERS[$HPV['server_id']]['srvr'])){
			fred::redirect('redirect.php?to=login.php', lang('invalid_server_id'));
		
		}elseif($CONFIG['servers_strict']){
			$mail_server      = $SERVERS[$HPV['server_id']]['srvr'];
			$mail_server_port = $SERVERS[$HPV['server_id']]['port'];
			$mail_server_type = $SERVERS[$HPV['server_id']]['type'];
			$mail_server_fold = $SERVERS[$HPV['server_id']]['fold'];

		}else{
			$mail_server      = isset($HPV['mail_server'])      ? $HPV['mail_server']      : $SERVERS[0]['srvr'];
			$mail_server_port = isset($HPV['mail_server_port']) ? $HPV['mail_server_port'] : $SERVERS[0]['port'];
			$mail_server_type = isset($HPV['mail_server_type']) ? $HPV['mail_server_type'] : $SERVERS[0]['type'];
			$mail_server_fold = isset($HPV['mail_server_fold']) ? $HPV['mail_server_fold'] : $SERVERS[0]['fold'];
		}

		$auth = auth::factory('mailserver');

		$params['username'] = $username;
		$params['password'] = $password;
		$params['mailsrvr'] = $mail_server;
		$params['srvrport'] = $mail_server_port;
		$params['srvrtype'] = $mail_server_type;

		if($auth->authenticate($params)){

			if(isset($SESSION['login']['mail_server']))      unset($SESSION['login']['mail_server']);
			if(isset($SESSION['login']['mail_server_port'])) unset($SESSION['login']['mail_server_port']);
			if(isset($SESSION['login']['mail_server_type'])) unset($SESSION['login']['mail_server_type']);
			if(isset($SESSION['login']['mail_server_fold'])) unset($SESSION['login']['mail_server_fold']);

			$SESSION['email']['srvr'] = $mail_server;
			$SESSION['email']['port'] = $mail_server_port;
			$SESSION['email']['type'] = $mail_server_type;
			$SESSION['email']['user'] = $username;
			$SESSION['email']['pass'] = base64_encode($password);
			$SESSION['email']['mbox'] = 'INBOX';
			$SESSION['email']['fold'] = $mail_server_fold;

			$SESSION['email']['smtp_srvr'] = !empty($SERVERS[@$HPV['server_id']]['smtp_srvr']) ? $SERVERS[$HPV['server_id']]['smtp_srvr'] : $mail_server;
			$SESSION['email']['smtp_port'] = !empty($SERVERS[@$HPV['server_id']]['smtp_port']) ? $SERVERS[$HPV['server_id']]['smtp_port'] : 25;
			$SESSION['email']['smtp_helo'] = !empty($SERVERS[@$HPV['server_id']]['smtp_helo']) ? $SERVERS[$HPV['server_id']]['smtp_helo'] : $HVV['SERVER_NAME'];
			$SESSION['email']['smtp_auth'] = !empty($SERVERS[@$HPV['server_id']]['smtp_auth']) ? $SERVERS[$HPV['server_id']]['smtp_auth'] : FALSE;
			$SESSION['email']['smtp_user'] = !empty($SERVERS[@$HPV['server_id']]['smtp_user']) ? $SERVERS[$HPV['server_id']]['smtp_user'] : '';
			$SESSION['email']['smtp_pass'] = !empty($SERVERS[@$HPV['server_id']]['smtp_pass']) ? $SERVERS[$HPV['server_id']]['smtp_pass'] : '';

			// Load up this users preferences
			include_once($CONFIG['includes'].'class.prefs.inc');
			$prefs =& prefs::factory($CONFIG['info_storage'], $CONFIG['info_storage_params']);
			$SESSION['userprefs'] = $prefs->read($username.'@'.$mail_server);

			// Set lang file variable in session
			$SESSION['common']['lang'] = isset($HPV['language']) ? $HPV['language'] : $CONFIG['default_lang'];
			$SESSION['common']['lang'] = isset($USERPREFS['settings']['lang']) ? $USERPREFS['settings']['lang'] : $SESSION['common']['lang'];

			// Perform Deleted Items clean up
			if((int)$SESSION['userprefs']['settings']['delete_items_older'] > 0){
				include($CONFIG['includes'] . 'clear.deleted.inc');
			}

			// Set first view so rules will run
			$SESSION['login']['first_view'] = TRUE;

			if(isset($SESSION['login']['redirect_to'])){
				$redirect_to =& $SESSION['login']['redirect_to'];
				unset($SESSION['login']['redirect_to']);
				fred::redirect($redirect_to);
				
			}else{
				fred::redirect('index.php');
			}

		}else{

			// Store details so user doesn't have to retype
			$SESSION['login']['mail_server']      = $mail_server;
			$SESSION['login']['mail_server_port'] = $mail_server_port;
			$SESSION['login']['mail_server_type'] = $mail_server_type;
			$SESSION['login']['mail_server_fold'] = $mail_server_fold;

			if(!empty($HPV['server_id'])){
				$SESSION['login']['server_id'] = $HPV['server_id'];
			}

			fred::redirect('redirect.php?to=login.php', lang('unknown_user'));
		}
	}

/***************************************
** Check for error_msg variable.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Get list of all templates, and the 
** default set to use.
***************************************/

	/***************************************
	** Get default.
	***************************************/

	if(!isset($SESSION['common']['tpl_set'])){

		$default_tpl_set = '';
		if(!empty($HOSTINFO['settings']['default_tpl_set'])){
			$default_tpl_set = $HOSTINFO['settings']['default_tpl_set'];
			$SESSION['common']['default_tpl_set'] =& $default_tpl_set;
		}else{
			$msg = 'Could not retrieve default template setting';
			die($msg);
		}
	}else{
		$default_tpl_set = $SESSION['common']['tpl_set'];
	}

/***************************************
** Perform configuration checks and show
** error template if any fail
***************************************/

	if($CONFIG['config_checks']){
		include($CONFIG['includes'] . 'config.checks.inc');
	}

	/***************************************
	** Get list of all template sets. And format
	** into a "loopable" variable ($template_sets)
	***************************************/

	foreach($HOSTINFO['tpls'] as $value){
		$selected = ($value['dirname'] == $default_tpl_set) ? 'SELECTED' : '';
		$template_sets[] = array('dirname' => $value['dirname'], 'label' => $value['label'], 'selected' => $selected);
	}

	if(!isset($template_sets)){
		$msg = 'Could not retrieve list of templates';
		die($msg);
	}

	/***************************************
    ** Get list of languages. Needs formating
	** into usable array.
    ***************************************/

	foreach($LANGUAGES as $key => $value){
		$selected = $key == $CONFIG['default_lang'] ? 'SELECTED' : '';
		$languages[] = array('code' => $key, 'desc' => $value, 'selected' => $selected);
	}

/***************************************
** Finally, template stuff.
***************************************/

	$mail_server      = isset($SESSION['login']['mail_server'])      ? $SESSION['login']['mail_server']      : $SERVERS[0]['srvr'];
	$mail_server_port = isset($SESSION['login']['mail_server_port']) ? $SESSION['login']['mail_server_port'] : $SERVERS[0]['port'];
	$mail_server_type = isset($SESSION['login']['mail_server_type']) ? $SESSION['login']['mail_server_type'] : $SERVERS[0]['type'];
	$mail_server_fold = isset($SESSION['login']['mail_server_fold']) ? $SESSION['login']['mail_server_fold'] : $SERVERS[0]['fold'];

	$tpl_default_mail_server      = $mail_server;
	$tpl_default_mail_server_port = $mail_server_port;
	$tpl_default_mail_server_fold = $mail_server_fold;

	$tpl_mail_server_type_imap = ($mail_server_type == 'imap' ? 'SELECTED' : '');
	$tpl_mail_server_type_pop3 = ($mail_server_type == 'pop3' ? 'SELECTED' : '');

	$TPL['template'] = 'login.html';
	include($CONFIG['includes'].'template.wrapper.inc');
?>