<?php
/***************************************
** Filename.......: preferences.folders.php
** Project........: Frederick
** Last Modified..: $Date: 2002/03/09 12:49:19 $
** CVS Revision...: $Revision&
** Copyright......: 2001, 2002 Richard Heyes 
***************************************/

	include('config.php');

/***************************************
** Logged in?
***************************************/

	auth::check_login('login.php', 'preferences.email.php');

/***************************************
** Remove any error message from the
** session and set the error_msg var for
** the template.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Form submitted?
***************************************/

	if(!empty($HPV)){

		foreach(array('sent_items_folder', 'draft_items_folder', 'deleted_items_folder') as $folder){
			if($HPV[$folder] != ''){
				$USERPREFS['settings'][$folder] = $HPV[$folder];
			}else{
				fred::redirect('redirect.php?to=preferences.folders.php', lang($folder.'_invalid'));
			}
		}

		$USERPREFS['settings']['empty_deleted_on_exit'] = @(bool)$HPV['empty_deleted_on_exit'];
		$USERPREFS['settings']['delete_items_older']    = @(int)$HPV['delete_items_older'];
		$USERPREFS['settings']['auto_subscribe_new']    = @(bool)$HPV['auto_subscribe_new'];

		// Save the preferences
		$result = save_prefs();

		fred::redirect('redirect.php?to=preferences.folders.php', $result ? lang('saved_ok') : '');
	}

/***************************************
** Get folder details for display
***************************************/
	if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){

		if($mailaccess->capabilities('folders')){

			$mailaccess->check_key_folders();

			$all_folders = $mailaccess->get_all_folders();

			for($i=0; $i<count($all_folders);$i++){
				if($all_folders[$i]['noselect'] == TRUE){
					$all_folders[$i]['name'] = '';
				}

				$sent_selected = (isset($USERPREFS['settings']['sent_items_folder'])
				                    AND $all_folders[$i]['name'] == $USERPREFS['settings']['sent_items_folder']) ? 'SELECTED' : '';
				$draft_selected = (isset($USERPREFS['settings']['draft_items_folder'])
				                      AND $all_folders[$i]['name'] == $USERPREFS['settings']['draft_items_folder']) ? 'SELECTED' : '';
				$deleted_selected = (isset($USERPREFS['settings']['deleted_items_folder'])
				                       AND $all_folders[$i]['name'] == $USERPREFS['settings']['deleted_items_folder']) ? 'SELECTED' : '';

				$all_folders[$i]['sent_selected'] = $sent_selected;
				$all_folders[$i]['draft_selected'] = $draft_selected;
				$all_folders[$i]['deleted_selected'] = $deleted_selected;
			}

		/***************************************
        ** No folders...
        ***************************************/

		}else{
			fred::redirect('index.php', lang('ef_no_folders'));
		}

	/***************************************
    ** Connect() failed
    ***************************************/

	}else{
		die(lang('failed_connect'));
	}

/***************************************
** Other prefs
***************************************/

	$form_empty_deleted_checked = @$USERPREFS['settings']['empty_deleted_on_exit'] == TRUE ? 'CHECKED' : '';
	$form_delete_items_older    = @(int)$USERPREFS['settings']['delete_items_older'];
	$form_auto_subscribe_new    = @$USERPREFS['settings']['auto_subscribe_new'] ? 'CHECKED' : '';

/***************************************
** Template stuff
***************************************/

	$TPL['template'] = 'preferences.folders.html';
	include($CONFIG['includes'].'template.wrapper.inc');

?>