<?php
/***************************************
** Filename.......: preferences.rules.php
** Project........: Frederick
** Last Modified..: $Date: 2002/03/13 15:10:52 $
** CVS Revision...: $Revision: 1.3 $
** Copyright......: 2001, 2002 Richard Heyes
***************************************/

	include('config.php');

/***************************************
** Logged in?
***************************************/

	auth::check_login('login.php', 'preferences.personal.php');

/***************************************
** Remove any error message from the
** session and set the error_msg var for
** the template.
***************************************/

	fred::error_msg($error_msg);

/***************************************
** Saving preferences
***************************************/

	if(!empty($HGV['saveprefs'])){
		$USERPREFS['settings']['apply_rules_always'] = (!empty($HPV['apply_rules']) AND $HPV['apply_rules'] == 'always');
		$USERPREFS['settings']['apply_rules_login']  = (!empty($HPV['apply_rules']) AND $HPV['apply_rules'] == 'login');
		$USERPREFS['settings']['apply_rules_never']  = (!empty($HPV['apply_rules']) AND $HPV['apply_rules'] == 'never');
		$USERPREFS['settings']['rules_only_unseen']  = !empty($HPV['rules_only_unseen']);
		$USERPREFS['settings']['rules_only_recent']  = !empty($HPV['rules_only_recent']);

		save_prefs();

		fred::redirect('redirect.php?to=preferences.rules.php', lang('saved_ok'));
	}

/***************************************
** Deleting/moving rules
***************************************/

	// Delete
	if(isset($HGV['delete']) AND $HGV['delete'] !== 'none' AND isset($USERPREFS['rules'][(int)$HGV['delete']])){
		unset($USERPREFS['rules'][(int)$HGV['delete']]);
		$USERPREFS['rules'] = array_values($USERPREFS['rules']);
		save_prefs();
		fred::redirect('redirect.php?to=preferences.rules.php');

	// Move up
	}elseif(isset($HGV['moveup']) AND isset($USERPREFS['rules'][(int)$HGV['moveup']])){

		$USERPREFS['rules'] = _array::swap($USERPREFS['rules'], (int)$HGV['moveup'], (int)$HGV['moveup'] - 1);
		save_prefs();
		fred::redirect('redirect.php?to=preferences.rules.php');

	// Move down
	}elseif(isset($HGV['movedown']) AND isset($USERPREFS['rules'][(int)$HGV['movedown']])){

		$USERPREFS['rules'] = _array::swap($USERPREFS['rules'], (int)$HGV['movedown'], (int)$HGV['movedown'] + 1);
		save_prefs();
		fred::redirect('redirect.php?to=preferences.rules.php');
	}


/***************************************
** Has form been submitted?
***************************************/

	if(!empty($HPV)){

		// Verify form has been filled in correctly
		if(!empty($HPV['from']))    $criteria[] = 'from';
		if(!empty($HPV['to']))      $criteria[] = 'to';
		if(!empty($HPV['cc']))      $criteria[] = 'cc';
		if(!empty($HPV['subject'])) $criteria[] = 'subject';
		if(!empty($HPV['body']))    $criteria[] = 'body';

		$SESSION['rules']['new_rule']['from']    = @$HPV['from'];
		$SESSION['rules']['new_rule']['to']      = @$HPV['to'];
		$SESSION['rules']['new_rule']['cc']      = @$HPV['cc'];
		$SESSION['rules']['new_rule']['subject'] = @$HPV['subject'];
		$SESSION['rules']['new_rule']['body']    = @$HPV['body'];
		$SESSION['rules']['new_rule']['actions'] = @$HPV['actions'];
		$SESSION['rules']['new_rule']['desc']    = @$HPV['description'];
		
		if(!isset($criteria)){
			fred::redirect('redirect.php?to=preferences.rules.php', lang('no_rule_crit'));

		}elseif(!isset($HPV['actions']) OR empty($HPV['actions'])){
			fred::redirect('redirect.php?to=preferences.rules.php', lang('no_rule_actions'));
		}

		// IMAP Extension doesn't do OR...
		//if(!empty($HPV['match'])) $match = ($HPV['match'] == 'any' ? 'any' : 'all'); else $match = 'all';
		//$SESSION['rules']['new_rule']['match'] = $match;

		/***************************************
        ** Build description
        ***************************************/

		$SESSION['rules']['new_rule']['desc'] = lang('match') . ' ';
		for($i=0; $i<count($criteria); $i++){
			$matches[] = '<i>&quot;' . $HPV[$criteria[$i]] . '&quot;</i> ' . lang('in') . ' <i>' . lang($criteria[$i]) . '</i>';
		}
		//$SESSION['rules']['new_rule']['desc'] .= implode($HPV['match'] == 'any' ? ' ' . lang('or') . ' ' : ', ', $matches) . ' ' . lang('and_then') . ' ';
		$SESSION['rules']['new_rule']['desc'] .= implode(', ', $matches) . ' ' . lang('and_then') . ' ';

		for($i=0; $i<count($HPV['actions']); $i++){
			switch(substr($HPV['actions'][$i], 0, 4)){
				case 'copy':
					$actions[] = '<i>' . lang('copy_to') . preg_replace('/^' . preg_quote($SESSION['email']['fold'], '/') . '/', '', substr($HPV['actions'][$i], strpos($HPV['actions'][$i], ':') + 1)) . '</i>';
					break;

				case 'move':
					$actions[] = '<i>' . lang('move_to') . ' ' . preg_replace('/^' . preg_quote($SESSION['email']['fold'], '/') . '/', '', substr($HPV['actions'][$i], strpos($HPV['actions'][$i], ':') + 1)) . '</i>';
					break;

				case 'mark':
					$actions[] = '<i>' . lang('mark_read') . '</i>';
					break;

				case 'flag':
					$actions[] = '<i>' . lang('flag_msg') . '</i>';
					break;

				case 'dele':
					$actions[] = '<i>' . lang('delete_msg') . '</i>';
					break;
			}
		}

		$SESSION['rules']['new_rule']['desc'] .= implode(' ' . lang('and') . ' ', $actions);

		/***************************************
        ** Update or addition?
        ***************************************/

		$index = (!empty($HPV['current_rules']) OR @$HPV['current_rules'] === '0') ? $HPV['current_rules'] : count(@$USERPREFS['rules']);

		$USERPREFS['rules'][$index] = $SESSION['rules']['new_rule'];
		unset($SESSION['rules']['new_rule']);

		save_prefs();

		fred::redirect('redirect.php?to=preferences.rules.php');
	}

/***************************************
** Form not submitted...
***************************************/

	if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){

		/***************************************
        ** Get list of subscribed folders
        ***************************************/

		if($mailaccess->capabilities('folders')){
			$mailaccess->check_key_folders();
			$folders = $mailaccess->get_subscribed_folders();
			for($i=0; $i<count($folders); $i++){
				// Remove name from unselectable mailboxes
				if($folders[$i]['noselect'] == TRUE){
					$folders[$i]['name'] = '';
				}
			}
			array_unshift($folders, array('name' => '', 'name_htmlsafe' => '', 'name_urlsafe' => '', 'text' => ''));
		}

	}else{
		die(lang('failed_connect'));
	}

/***************************************
** Template stuff
***************************************/

	$tpl_prefix_len = strlen($SESSION['email']['fold']);
	$rules = is_array(@$USERPREFS['rules']) ? $USERPREFS['rules'] : array();

	$js_escape = array("\r" => '\r', "\n" => '\n', "\t" => '\t', "'" => "\\'", '\\' => '\\\\');
	for($i=0; $i<count($rules); $i++){
		$rules[$i]['from']    = strtr($rules[$i]['from'], $js_escape);
		$rules[$i]['to']      = strtr($rules[$i]['to'], $js_escape);
		$rules[$i]['cc']      = strtr($rules[$i]['cc'], $js_escape);
		$rules[$i]['subject'] = strtr($rules[$i]['subject'], $js_escape);
		$rules[$i]['body']    = strtr($rules[$i]['body'], $js_escape);
		$rules[$i]['desc']    = strtr($rules[$i]['desc'], $js_escape);
	}

	// Set preferences
	$form_apply_rules_always_checked = @$USERPREFS['settings']['apply_rules_always'] ? 'checked="checked"' : '';
	$form_apply_rules_login_checked  = @$USERPREFS['settings']['apply_rules_login']  ? 'checked="checked"' : '';
	$form_apply_rules_never_checked  = @$USERPREFS['settings']['apply_rules_never']  ? 'checked="checked"' : '';
	$form_rules_only_unseen_checked  = @$USERPREFS['settings']['rules_only_unseen']  ? 'checked="checked"' : '';
	$form_rules_only_recent_checked  = @$USERPREFS['settings']['rules_only_recent']  ? 'checked="checked"' : '';

	$TPL['template'] = 'preferences.rules.html';
	include($CONFIG['includes'].'template.wrapper.inc');

?>