<?php
/***************************************
** Filename.......: class.auth.inc
** Project........: Frederick
** Last Modified..: 04 November 2001
** Copyright......: Richard Heyes 2001
***************************************/

class auth{

	/***************************************
    ** This factory method returns an appropriate
	** object based on what storage method
	** is being used.
    ***************************************/

	function &factory($driver){
		global $CONFIG;
		
		if(file_exists($CONFIG['includes'].'class.auth_'.$driver.'.inc')){
			include_once($CONFIG['includes'].'class.auth_'.$driver.'.inc');
			$obj_name = 'auth_'.$driver;
			return new $obj_name($params);

		}else{
			return FALSE;
		}
	}

	/***************************************
    ** Function to check whether someone is
	** logged in or not. Checks the data held
	** in the session
    ***************************************/
	
	function is_logged_in(){
		global $SESSION;
	
		return (isset($SESSION['login']['logged_in']) AND $SESSION['login']['logged_in'] == TRUE);
	}

	/***************************************
    ** Function to check the login status,
	** and if not logged in  redirect them
	** to a page, and set the session redirect_to
	** variable.
    ***************************************/

	function check_login($login_page, $redirect_to){
		global $SESSION, $LANG;

		if(!auth::is_logged_in()){
			$SESSION['login']['redirect_to'] = $redirect_to;
			fred::redirect($login_page);
		}
	}
}
?>