<?php
/***************************************
** Filename.......: class.crypto.inc
** Project........: Frederick
** Last Modified..: 03 November 2001
** Copyright......: Richard Heyes 2001
***************************************/

/***************************************
** An abstraction class for encryption
** Will use the mcrypt php extension if
** available, the PEAR HCEMD5 class if not.
** If neither are available, it will fall
** back to base64 encoding.
***************************************/

class crypto{

	/***************************************
    ** Factory function to return an
	** appropriate object
    ***************************************/

	function &factory($key = null){
		global $CONFIG;

		if(!isset($key))
			$key = 'yek_terces';

		if(extension_loaded('mcrypt') AND phpversion() != '4.0.6'){
			include_once($CONFIG['includes'].'class.crypto_mcrypt.inc');
			return new crypto_mcrypt($CONFIG['crypto_key']);

		}elseif(@fopen('Crypt/HCEMD5.php', 'r', TRUE)){
			include('Crypt/HCEMD5.php');
			return new Crypt_HCEMD5($CONFIG['crypto_key']);

		}else{
			return new crypto();
		}
	}

	/***************************************
    ** Basic function to use base64 encoding
	** to "encrypt" the data
    ***************************************/

	function encrypt($data){

		return base64_encode($data);
	}	

	/***************************************
    ** Basic function to use base64 decoding
	** to "decrypt" the data
    ***************************************/
	
	function decrypt($data){

		return base64_decode($data);
	}
}

?>