<?php
/***************************************
** Filename.......: class.mailaccess_imapext.inc
** Project........: Frederick
** Last Modified..: 13 November 2001
***************************************/

	class mailaccess_imapext extends mailaccess{

		var $connection;
		var $mailbox;
		var $host;
		var $port;
		var $type;
		var $mbox;
		var $user;
		var $pass;


		/***************************************
        ** Constructor
        ***************************************/

		function mailaccess_imapext(){
			return TRUE;
		}

		/***************************************
        ** Connection function
		** Returns TRUE/FALSE
        ***************************************/

		function connect($host, $user, $pass, $port, $type, $mbox = 'INBOX'){
			$imp = @imap_open('{'.$host.':'.$port.'/'.$type.'}'.$mbox, $user, $pass);

			if($imp){

				$this->connection =& $imp;
				$this->host = $host;
				$this->port = $port;
				$this->type = $type;
				$this->mbox = $mbox;
				$this->user = $user;
				$this->pass = $pass;

				return TRUE;

			}else
				return FALSE;
		}

		/***************************************
        ** Reconnects to server. Used for looking
		** at mailboxes other than the current.
        ***************************************/

		function reconnect($mbox = 'INBOX'){

			$this->mbox = $mbox;
			return @imap_reopen($this->connection, $this->create_folder_string($mbox));
		}

		/***************************************
        ** Closes a connection
        ***************************************/

			function close(){
				return imap_close($this->connection);
			}		

		/***************************************
        ** Returns capabilities
        ***************************************/
		
		function capabilities($attrib){
			global $SESSION;

			switch($attrib){
				case 'folders':
					return ($SESSION['email']['type'] == 'imap');
					break;

				case 'search':
					return TRUE;
					break;

				default:
					return FALSE;
			}
		}

		/***************************************
        ** Creates a folder string in the format:
		** {host:port/type}folder
        ***************************************/

		function create_folder_string($folder = '', $mailbox_only = FALSE){
			global $SESSION;
			
			if($mailbox_only == TRUE){
				$return = ($folder == 'INBOX' ?  'INBOX' : $folder);

			}else{
				if($folder == ''){
					$return = '{'.$this->host.':'.$this->port.'/'.$this->type.'}';
	
				}elseif($folder == 'INBOX'){
					$return = '{'.$this->host.':'.$this->port.'/'.$this->type.'}INBOX';
	
				}else{
					$return = '{'.$this->host.':'.$this->port.'/'.$this->type.'}'.imap_utf7_encode($folder);
				}
			}
			
			return $return;
		}

		/***************************************
        ** Gets folders, either subscribed or
		** all.
        ***************************************/

		function get_folders($func_type, $get_sizes = FALSE){
			global $SESSION;

			$function = ($func_type == 'subscribed' ? 'imap_getsubscribed' : 'imap_getmailboxes');
			$folders  = $function($this->connection, $this->create_folder_string(), $SESSION['email']['fold'].'*');
			$folders  = array_merge(imap_getmailboxes($this->connection, $this->create_folder_string(), 'INBOX'), $folders);

			if(is_array($folders)){
				foreach($folders as $folder){
					if(!empty($folder->delimiter) AND !isset($delimiter)){
						$delimiter = $folder->delimiter;
					}
					$name = substr(imap_utf7_decode($folder->name), strpos(imap_utf7_decode($folder->name), '}') + 1);
					$path = !empty($folder->delimiter) ? preg_split('/'.preg_quote($folder->delimiter, '/').'/', $name) : array($name);
					for($i=0; $i<count($path); $i++){
						if(empty($path[$i])){
							unset($path[$i]);
						}
					}
					$path = array_values($path);
					$eval = '$return[\''.implode('\'][\'', $path).'\'] = array();';
					eval($eval);
				}

				$folder_tree = new folder('/');
				parse_folder_array($return, $folder_tree);
				$return = array();
				$folder_tree->get_flat_array($this, $return, '', $delimiter, $get_sizes);

				// New code in 1.2... Don't show unselectable folders
				// Unless it's a subfolder...
				for($i=0, $cnt = count($return); $i<$cnt; $i++){
					if($return[$i]['noselect'] == TRUE AND basename($SESSION['email']['fold']) == $return[$i]['name']){
						unset($return[$i]);
					}
				}
				$return = array_values($return);
			}else{
				$return[] = array('name' => 'INBOX', 'text' => 'INBOX');
			}
			
			return $return;
		}

		/***************************************
        ** Returns list of subscribed folders
        ***************************************/

		function get_subscribed_folders(){
			global $HOSTINFO;

			if(@$HOSTINFO['settings']['cache_email_folders']){
				if($folders = $this->cache_get('subscribed_folders')){	
					return $folders;
				}else{
					$folders = $this->get_folders('subscribed');
					$this->cache_add('subscribed_folders', $folders);
					return $folders;
				}
			}else{
				return $this->get_folders('subscribed');
			}
		}

		/***************************************
        ** Returns a list of all folders
        ***************************************/
		
		function get_all_folders($get_sizes = FALSE){

			return $this->get_folders('all', $get_sizes);
		}

		/***************************************
        ** Returns some information about a
		** folder.
        ***************************************/
		
		function get_folder_info($folder_name, $get_sizes = FALSE){

			$folders = imap_getmailboxes($this->connection, $this->create_folder_string(), imap_utf7_encode($folder_name));

			if($folders){
				foreach($folders as $folder){
					$name = substr(imap_utf7_decode($folder->name), strpos(imap_utf7_decode($folder->name), '}') + 1);
	
					$return[$name]['noinferiors'] = ($folder->attributes & LATT_NOINFERIORS) == LATT_NOINFERIORS;
					$return[$name]['noselect']    = ($folder->attributes & LATT_NOSELECT) == LATT_NOSELECT;
					$return[$name]['messages']    = 0;
					$return[$name]['unseen']      = 0;
					$return[$name]['size']        = '';
	
					if($get_sizes){
						$this->reconnect($folder_name);
						$mailboxmsginfo = imap_mailboxmsginfo($this->connection);
						$this->reconnect($this->mbox);
	
						$return[$name]['messages']    = $mailboxmsginfo->Nmsgs;
						$return[$name]['unseen']      = $mailboxmsginfo->Unread;
						$return[$name]['size']        = '';
	
						// Format the size
						if($mailboxmsginfo->Size == 0){
							$size = '0';
						}elseif($mailboxmsginfo->Size >= 1048576){
							$size = number_format($mailboxmsginfo->Size / 1048576, 1).'Mb';
						}elseif($mailboxmsginfo->Size >= 1024){
							$size = number_format($mailboxmsginfo->Size / 1024).'Kb';
						}else{
							$size = $mailboxmsginfo->Size.'b';
						}
	
						$return[$name]['size'] = $size;
					}
				} // End foreach
			}

			imap_errors();
			return @$return;
		}

		/***************************************
        ** Moves message from folder to folder
        ***************************************/

		function move_msg($msg_ids, $to){

			$d_msg_ids = implode(',', $this->get_msg_ids(1,1,1,0, 'DELETED',$num_msgs));
			$this->setflag($d_msg_ids, 'undeleted');

			$result = imap_mail_move($this->connection, $msg_ids, $this->create_folder_string($to, TRUE), CP_UID);
			$this->expunge();
			$this->setflag($d_msg_ids, 'deleted');

			return $result;
		}
		
		/***************************************
        ** Copies message from folder to folder
        ***************************************/
		
		function copy_msg($msg_ids, $to){

			return imap_mail_copy($this->connection, $msg_ids, $this->create_folder_string($to, TRUE), CP_UID);
		}

		/***************************************
        ** Checks whether a folder exists or not
        ***************************************/
		
		function folder_exists($folder){

			$folders = imap_listmailbox($this->connection, $this->create_folder_string(), $this->create_folder_string($folder, TRUE));
			return (!empty($folders));
		}

		/***************************************
        ** Create a folder
        ***************************************/
		
		function create_folder($folder){

			$this->cache_remove('subscribed_folders');
			return imap_createmailbox($this->connection, $this->create_folder_string($folder));
		}

		/***************************************
        ** Delete a folder
        ***************************************/
		
		function delete_folder($folder){

			$this->cache_remove('subscribed_folders');
			return imap_deletemailbox($this->connection, $this->create_folder_string($folder));
		}

		/***************************************
        ** Rename a folder
        ***************************************/
		
		function rename_folder($from, $to){

			$this->cache_remove('subscribed_folders');
			if($this->is_subscribed($from)){
				$this->unsubscribe_folder($from);
				$result = imap_renamemailbox($this->connection, $this->create_folder_string($from), $this->create_folder_string($to));
				$this->subscribe_folder($result ? $to : $from); // Either subscribe to new, or resubscribe to old.
			}else{
				$result = imap_renamemailbox($this->connection, $this->create_folder_string($from), $this->create_folder_string($to));
			}

			return $result;
		}

		/***************************************
        ** Tells whether a folder is subscribed
		** or not
        ***************************************/

		function is_subscribed($folder){
			global $SESSION;
			static $folders;
			
			if(!isset($folders)){
				$folders = imap_getsubscribed($this->connection, $this->create_folder_string(), $SESSION['email']['fold'] . '*');
				foreach($folders as $value){
					$tmp[] = substr($value->name, strpos($value->name, '}') + 1);
				}
				$folders = $tmp;
			}

			return in_array($folder, $folders);
		}

		/***************************************
        ** Function to subscribe to a folder
        ***************************************/
		
		function subscribe_folder($folder){

			return imap_subscribe($this->connection, $this->create_folder_string($folder));
		}
		
		/***************************************
        ** Function to unsubscribe from a folder
        ***************************************/
		
		function unsubscribe_folder($folder){

			$this->cache_remove('subscribed_folders');
			return imap_unsubscribe($this->connection, $this->create_folder_string($folder));
		}

		/***************************************
        ** Sets flags on messages
        ***************************************/
		
		function setflag($msg_ids, $flag){
			switch($flag){
				case 'answered':
					return imap_setflag_full($this->connection, $msg_ids, '\\Answered', ST_UID);
					break;

				case 'unanswered':
					return imap_clearflag_full($this->connection, $msg_ids, '\\Answered', ST_UID);
					break;

				case 'deleted':
					return imap_setflag_full($this->connection, $msg_ids, '\\Deleted', ST_UID);
					break;

				case 'undeleted':
					return imap_clearflag_full($this->connection, $msg_ids, '\\Deleted', ST_UID);
					break;

				case 'draft':
					return imap_setflag_full($this->connection, $msg_ids, '\\Draft', ST_UID);
					break;

				case 'undraft': // :-/
					return imap_clearflag_full($this->connection, $msg_ids, '\\Draft', ST_UID);
					break;
				
				case 'flagged':
					return imap_setflag_full($this->connection, $msg_ids, '\\Flagged', ST_UID);
					break;
				
				case 'unflagged':
					return imap_clearflag_full($this->connection, $msg_ids, '\\Flagged', ST_UID);
					break;

				case 'read':
					return imap_setflag_full($this->connection, $msg_ids, '\\Seen', ST_UID);
					break;

				case 'unread':
					return imap_clearflag_full($this->connection, $msg_ids, '\\Seen', ST_UID);
					break;

				default:
					return FALSE;
			}
		}

		/***************************************
        ** Appends a message to a folder
        ***************************************/

		function append($message, $folder = NULL){
			global $SESSION, $USERPREFS;
			if(!isset($folder)){
				$folder = !empty($USERPREFS['settings']['sent_items_folder']) ? $USERPREFS['settings']['sent_items_folder'] : $SESSION['email']['fold'].'sent-mail';
			}
			return imap_append($this->connection, $this->create_folder_string($folder), $message, '\\Seen');
		}

		/***************************************
        ** Function checks for key folders,
		** ie Deleted|Sent Items
        ***************************************/
		
		function check_key_folders(){
			global $SESSION, $USERPREFS;
			
			$draft_folder   = !empty($USERPREFS['settings']['draft_items_folder'])   ? $USERPREFS['settings']['draft_items_folder']   : $SESSION['email']['fold'].'drafts';
			$deleted_folder = !empty($USERPREFS['settings']['deleted_items_folder']) ? $USERPREFS['settings']['deleted_items_folder'] : $SESSION['email']['fold'].'deleted-mail';
			$sent_folder    = !empty($USERPREFS['settings']['sent_items_folder'])    ? $USERPREFS['settings']['sent_items_folder']    : $SESSION['email']['fold'].'sent-mail';

			foreach(array('INBOX', $draft_folder, $deleted_folder, $sent_folder) as $folder){
				if(!$this->folder_exists($folder)){
					$this->create_folder($folder);
				}
				$this->subscribe_folder($folder);
			}
			
			imap_errors();
		}

		/***************************************
        ** Returns structured header information
        ***************************************/

		function headerinfo($msg_id){

			$msg_id = imap_msgno($this->connection, $msg_id);
			$info = @imap_headerinfo($this->connection, $msg_id);
			return $info ? $info : FALSE;
		}

		/***************************************
        ** Returns messages raw headers, as is.
		** Includes a blank line at the end.
        ***************************************/

		function get_raw_headers($msg_id, $partno = NULL){

			if(!isset($partno)){
				$headers = imap_fetchheader($this->connection, $msg_id, FT_UID);
				return $headers ? $headers : FALSE;
				
			}else{

				$body = imap_fetchbody($this->connection, $msg_id, $partno, FT_UID);
				$headers = substr($body, 0, strpos($body, "\r\n\r\n")+4);
				return $headers ? $headers : FALSE;
			}
		}

		/***************************************
        ** Returns the body of a message.
        ***************************************/

		function get_body($msg_id, $partno = NULL, $is_message = FALSE){

			if(!isset($partno)){
				$body = imap_body($this->connection, $msg_id, FT_UID);
				return $body ? $body : FALSE;

			}else{

				$body = imap_fetchbody($this->connection, $msg_id, $partno, FT_UID);
				if($body){
					if($is_message)
						$body = substr($body, strpos($body, "\r\n\r\n")+4);
					return $body;
				}else{
					return FALSE;
				}
			}
		}

		/***************************************
        ** Returns number of messages
        ***************************************/

		function num_msg(){

			$num = imap_num_msg($this->connection);
			return $num ? $num : 0;
		}

		/***************************************
        ** Marks messages for deletion. $msg_ids
		** can be a single msg_id, or a comma
		** seperated list of msg_ids.
        ***************************************/

		function delete($msg_ids, &$message){
			global $SESSION;
			
			$deleted_items_folder = $SESSION['userprefs']['settings']['deleted_items_folder'];

			// Need to determine which msgs are currently marked as deleted, and unmark
			// them since expunging would remove them.
			$d_msg_ids = $this->get_msg_ids(1, 1, 1, 0, 'DELETED', $num_msgs);
			$this->setflag(implode(',', $d_msg_ids), 'undeleted');

			if(!$this->capabilities('folders') OR $SESSION['email']['mbox'] == $deleted_items_folder){
				imap_delete($this->connection, $msg_ids, FT_UID);
				$this->expunge();
				$message = NULL;

			}else{
				// Move to deleted items folder
				if(!$this->folder_exists($deleted_items_folder)){
					if(!$this->create_folder($deleted_items_folder)){
						$message = lang('create_trash_failed');
					}
					$this->subscribe_folder($deleted_items_folder);
				}
				
				$message = $this->move_msg($msg_ids, $deleted_items_folder) ? NULL : lang('move_failed');
				$this->expunge();
			}
			
			$this->setflag(implode(',', $d_msg_ids), 'deleted');
		}

		/***************************************
        ** Function to *actually* delete the 
		** messages currently marked for deletion
        ***************************************/

		function expunge(){

			return imap_expunge($this->connection);
		}

		/***************************************
        ** Returns msg_ids based on:
		** sorting, asc/desc, start_msg, show_per_page
        ***************************************/

		function get_msg_ids($sort, $ascdesc, $start_msg, $per_page = 0, $search = 'ALL', &$num_msgs){
			global $SESSION, $HOSTINFO;

			switch($sort){
				case 'from':
					$sort = SORTFROM;
					break;

				case 'subject':
					$sort = SORTSUBJECT;
					break;

				case 'to':
					$sort = SORTTO;
					break;
				
				case 'size':
					$sort = SORTSIZE;
					break;

				case 'date':
					$sort = SORTDATE;
					break;

				case 'arrival':
					$sort = SORTARRIVAL;
					break;
			}

			if($sort == SORTARRIVAL AND $search == 'ALL'){
				$msg_ids = array();
				$total_num_msgs = imap_num_msg($this->connection);
				$num_msgs = $total_num_msgs;
				if($total_num_msgs > 0){
					$msg_ids = $ascdesc ? array_reverse(range(1, $total_num_msgs)) : range(1, $total_num_msgs);
					$msg_ids = array_slice($msg_ids, $start_msg-1, $per_page == 0 ? count($msg_ids) : $per_page);
					for($i=0; $i<count($msg_ids); $i++){
						$msg_ids[$i] = @imap_uid($this->connection, $msg_ids[$i]);
					}
				}
			}else{
				$msg_ids  = imap_sort($this->connection, $sort, $ascdesc, SE_UID|SE_NOPREFETCH, $search);
				$num_msgs = count($msg_ids);
				$msg_ids  = array_slice($msg_ids, $start_msg-1, $per_page == 0 ? count($msg_ids) : $per_page);
			}

			// Clear cache if number of messages has changed?
			if(@$HOSTINFO['settings']['refresh_email_list'] AND @$SESSION['email']['num_msgs'] != $msg_ids){
				$this->cache_clear();
			}
			return $msg_ids;
		}

		/***************************************
        ** Returns a summary of the message for
		** the listing page.
        ***************************************/

		function get_msg_summary($msg_id){

			global $LANG, $SESSION, $HOSTINFO;

			/***************************************
            ** Get from cache if it's there
            ***************************************/

			if($data = $this->cache_get($msg_id . ':' . $this->mbox)){
				return $data;
			}

			/***************************************
            ** Not in the cache :(
            ***************************************/

			$headers = $this->headerinfo($msg_id);

			// Any attachments?
			$raw_header  = imap_fetchheader($this->connection, $msg_id, FT_UID);
			$attachments = preg_match('/Content-Type: multipart\/mixed/im', $raw_header) ? lang('attachment_icon') : '';

			// Importance header?
			$importance = preg_match('/^Importance: High/im', $raw_header) ? lang('important_icon') : '';

			// Determine Size
			if(isset($headers->Size)){
				if($headers->Size > 1048576)  $size = round($headers->Size/1048576, 1).' Mb';
				elseif($headers->Size > 1024) $size = round($headers->Size/1024   , 1).' Kb';
				else                          $size = $headers->Size.' b';
			}else
				$size = '&nbsp;';

			// From address
			if(isset($headers->from)){
				$email = $headers->from[0]->mailbox.'@'.$headers->from[0]->host;
				$name  = isset($headers->from[0]->personal) ? decode_header($headers->from[0]->personal) : $email;
			}else{
				$email = '';
				$name  = 'Unknown';
			}

			// To address
			if(isset($headers->to)){
				$to_email = $headers->to[0]->mailbox.'@'.@$headers->to[0]->host;
				$to_name  = isset($headers->to[0]->personal) ? decode_header($headers->to[0]->personal) : $to_email;
			}else{
				$to_email = '';
				$to_name  = 'Unknown';
			}

			// Subject
			$subject = (isset($headers->subject) AND trim($headers->subject) != '') ? decode_header($headers->subject) : lang('no_subject');
			// FIXME Make this max subject length configurable
			if(strlen($subject) > 80){
				$subject = substr($subject, 0, 80).'...';
			}

			// Return as array of properties
			$ret = array(
						 'msg_id'        => $msg_id,
						 'date'          => date('H:i jS M Y', $headers->udate),
						 'email'         => htmlspecialchars($email),
						 'name'          => htmlspecialchars($name),
						 'email_urlsafe' => urlencode(sprintf('"%s" <%s>', $name, $email)),
						 'to_email'      => htmlspecialchars($to_email),
						 'to_name'       => htmlspecialchars($to_name),
						 'to_urlsafe'    => urlencode(sprintf('"%s" <%s>', $to_name, $to_email)),
						 'subject'       => htmlspecialchars($subject),
						 'size'          => $size,
						 'attachments'   => $attachments,
						 'importance'    => $importance,
						 'deleted'       => ($headers->Deleted == 'D' ? lang('deleted_icon') : ''),
						 'flagged'       => ($headers->Flagged == 'F' ? lang('flagged_icon') : ''),
						 'unread'        => ($this->type == 'imap' AND ($headers->Unseen == 'U' OR $headers->Recent == 'N'))
						);

			// Cache the summary information
			if(@$HOSTINFO['settings']['cache_email_list']){
				$this->cache_add($msg_id . ':' . $this->mbox, $ret);
			}
			return $ret;
		}

		/***************************************
        ** Send function specific to this driver
        ***************************************/

		function send($to, $subject, $body, $headers, $cc, $bcc){
			return imap_mail($to, $subject, $body, $headers, $cc, $bcc);
		}

		/***************************************
        ** Clears the cache
        ***************************************/
		
		function cache_clear(){
			global $SESSION;
			
			if(isset($SESSION['cache'])){
				unset($SESSION['cache']);
			}
		}

		/***************************************
        ** Cache add function
        ***************************************/

		function cache_add($uid, $data){
			global $SESSION;

			$SESSION['cache'][$uid] = $data;
		}
		
		/***************************************
        ** Cache remove function
        ***************************************/
		
		function cache_remove($uid){
			global $SESSION;
			
			if(isset($SESSION['cache'][$uid])){
				unset($SESSION['cache'][$uid]);
			}
		}
		
		/***************************************
        ** Cache get function
        ***************************************/
		
		function cache_get($uid){
			global $SESSION;

			return isset($SESSION['cache'][$uid]) ? $SESSION['cache'][$uid] : FALSE;
		}

	} // End of class

/***************************************
** Folder class
***************************************/

	class folder{
	
		var $folder_name;
		var $subfolders;
		
		function folder($name){
			$this->folder_name = $name;
			$this->subfolders  = array();
		}

		function &add_subfolder($folder_obj){
			$this->subfolders[] = $folder_obj;
			return $this->subfolders[count($this->subfolders) - 1];
		}

		/***************************************
        ** Returns an array of folders in the style:
		** array(
		**       array(
		**             'name' => <actual name & path of folder>
		**             'text' => <display name>
		**            )
		**       ...
		**      )
        ***************************************/

		function get_flat_array(&$mailaccess, &$return, $path, $delimiter, $get_sizes, $indent = 0){
			global $SESSION;

			$indent_str = '&nbsp;&nbsp;&nbsp;&nbsp;';
			for($i=0; $i<count($this->subfolders); $i++){

				if(is_object($this->subfolders[$i])){

					$folder_name = ($path == '' ? '' : $path.$delimiter).$this->subfolders[$i]->folder_name;
					$folder_info = $mailaccess->get_folder_info($folder_name, $get_sizes);

					$name = ($this->subfolders[$i]->folder_name == 'INBOX' ? 'INBOX' : ($path == '' ? '' : $path.$delimiter).$this->subfolders[$i]->folder_name);
					$return[] = array(
					                  'messages'      => $folder_info[$name]['noselect'] ? '' : $folder_info[$name]['messages'],
									  'unseen'        => $folder_info[$name]['noselect'] ? '' : $folder_info[$name]['unseen'],
									  'size'          => $folder_info[$name]['size'],
					                  'noselect'      => $folder_info[$name]['noselect'],
					                  'name'          => $name,
									  'name_htmlsafe' => htmlspecialchars($name),
									  'name_urlsafe'  => urlencode($name),
					                  'text'          => str_repeat($indent_str, $indent).htmlspecialchars($this->subfolders[$i]->folder_name)
					                 );

					$this->subfolders[$i]->get_flat_array($mailaccess, $return, ($path == '' ? '' : $path.$delimiter).$this->subfolders[$i]->folder_name, $delimiter, $get_sizes, $indent + 1);

				}
/*
				else{

					$return[] = array(
					                  'name' => ($path == '' ? '' : $path.$delimiter).$this->subfolders[$i],
					                  'text' => str_repeat($indent_str, $indent).$this->subfolders[$i]
					                 );
				}*/
			}
		}
	}

/***************************************
** Function used by the get_folders()
** function. Given an array with the
** right structure it will produce a 
** folder tree using the folder object
***************************************/

	function parse_folder_array($array, &$tree){
		if(!empty($array)){		
			foreach($array as $key => $value){
				$branch =& $tree->add_subfolder(new folder($key));
				if(!empty($value)){
					parse_folder_array($value, $branch);
				}
			}
		}
	}
?>
