<?php
/***************************************
** filename.......: config.checks.inc
** project........: frederick
** last modified..: $date$
** cvs revision...: $revision$
** copyright......: 2001, 2002 richard heyes
***************************************/

/***************************************
** directories
***************************************/

	$hostinfo_error  = !is_readable($CONFIG['data_dir'] . 'hostinfo');
	$hostinfow_error = !is_writeable($CONFIG['data_dir'] . 'hostinfo');
	$defuser_error   = !is_readable($CONFIG['data_dir'] . 'default.user');
	$address_error   = !is_readable($CONFIG['data_dir'] . 'addressbook');
	
	$tmpdir_error   = !is_writeable($CONFIG['tmp_dir']);

/***************************************
** version
***************************************/

	preg_match('/([3-5])\.([0-9])\.([0-9])/', phpversion(), $matches);
	$major_ver = $matches[1];
	$med_ver   = $matches[2];
	$minor_ver = $matches[3];
	
	$version_error = ( $major_ver < 4 OR ($minor_ver < 4 AND $med_ver == 0) );

/***************************************
** imap extension
***************************************/

	$imap_error = !extension_loaded('imap');

/***************************************
** did we fail... or not...
***************************************/

	if($version_error OR $imap_error OR $hostinfo_error OR $hostinfow_error OR $defuser_error OR $address_error OR $tmpdir_error){

		$version_font = $version_error ? 'ff0000' : '009900';
		$version_text = phpversion();

		$extension_font = $imap_error ? 'ff0000' : '009900';
		$extension_text = $imap_error ? 'Not loaded!' : 'Loaded';

		$hostinfo_font = $hostinfo_error ? 'ff0000' : '009900';
		$hostinfo_text = $hostinfo_error ? 'Could not read!' : 'Ok';

		$hostinfow_font = $hostinfow_error ? 'ff0000' : '009900';
		$hostinfow_text = $hostinfow_error ? 'Could not write!' : 'Ok';

		$defuser_font = $defuser_error ? 'ff0000' : '009900';
		$defuser_text = $defuser_error ? 'Could not read!' : 'Ok';

		$address_font = $address_error ? 'ff0000' : '009900';
		$address_text = $address_error ? 'Could not read!' : 'Ok';

		$tmpdir_font = $tmpdir_error ? 'ff0000' : '009900';
		$tmpdir_text = $tmpdir_error ? 'Not writeable!' : 'Ok';
?>
<html>
<head>
	<title>Configuration errors!</title>
	<style type="text/css">
	<!--
		BODY,TD {font-family: Arial, Verdana, Helvetica, Sans-Serif}
	// -->
	</style>
</head>
<body>

<table border="0" align="CENTER" height="100%">
	<tr>
		<td height="50%">&nbsp;</td>
	</tr>

	<tr>
		<td align="CENTER"><h2>Configuration error</h2></td>
	</tr>

	<tr>
		<td>
			Unfortunately this application needs the imap extension <br> loaded and the version of php to be at least 4.0.4 to run.<br />
			Other configuration parameters may also be faulty.
		</td>
	</tr>

	<tr><td>&nbsp;</td></tr>

	<tr>
		<td>
			<ul>
				<li>IMAP Extension loaded: <font color="#<?=$extension_font?>"><?=$extension_text?></font></li>
				<li>PHP Version: <font color="#<?=$version_font?>"><?=$version_text?></font></li>
			</ul>
			<ul>
				<li>"hostinfo" file readable: <font color="#<?=$hostinfo_font?>"><?=$hostinfo_text?></font></li>
				<li>"hostinfo" file writeable: <font color="#<?=$hostinfow_font?>"><?=$hostinfow_text?></font></li>
				<li>"default.user" file readable: <font color="#<?=$defuser_font?>"><?=$defuser_text?></font></li>
				<li>"addressbook" file readable: <font color="#<?=$address_font?>"><?=$address_text?></font></li>
				<li>Temp directory writeable: <font color="#<?=$tmpdir_font?>"><?=$tmpdir_text?></font></li>
			</ul>
		</td>
	</tr>

	<tr>
		<td height="50%">&nbsp;</td>
	</tr>
</table>
<?php
		exit();
	}
?>