<?php
/***************************************
** Filename.......: email.list.normal.inc
** Project........: Frederick
** Last Modified..: $Date: 2002/04/07 18:03:25 $
** CVS Revision...: $Revision: 1.13.2.2 $
** Copyright......: 2001, 2002 Richard Heyes
***************************************/

/***************************************
** Normal list routine for mailbox
***************************************/

	if($mailaccess->connect($SESSION['email']['srvr'], $SESSION['email']['user'], base64_decode($SESSION['email']['pass']), $SESSION['email']['port'], $SESSION['email']['type'], $SESSION['email']['mbox'])){

		/***************************************
        ** Get list of subscribed folders
        ***************************************/

		if($mailaccess->capabilities('folders')){

			$mailaccess->check_key_folders();
			$folders = $mailaccess->get_subscribed_folders();

			// FIXME Check for whether current folder is subscribed folder?
			for($i=0; $i<count($folders); $i++){
				// Remove name from unselectable mailboxes
				if($folders[$i]['noselect'] == TRUE){
					$folders[$i]['name'] = '';
				}
				//Make current mbox selected
				$folders[$i]['selected'] = ($folders[$i]['name'] == $SESSION['email']['mbox'] ? 'SELECTED' : '');
			}
		}

		/***************************************
        ** Rules baby!
        ***************************************/

		if(    $mailaccess->capabilities('folders')
		   AND $SESSION['email']['mbox'] == 'INBOX'
		   AND !empty($USERPREFS['rules'])
		   AND (@$USERPREFS['settings']['apply_rules_always'] OR (@$USERPREFS['settings']['apply_rules_login'] AND @$SESSION['login']['first_view']) OR !empty($HGV['filter'])) ){

			if(isset($SESSION['login']['first_view'])){
				unset($SESSION['login']['first_view']);
			}

			$do_rules = TRUE;

			// Check first if we only apply to unread messages. If so check if there
			// any unread messages. If not, there's no point applying rules.
			if(@$USERPREFS['settings']['rules_only_unseen']){
				$mailaccess->get_msg_ids($order_by, $ascdesc, 1, 0, 'UNSEEN', $num_msgs);
				$do_rules = ($num_msgs == 0) ? FALSE : TRUE;
				$search_prepend[] = 'UNSEEN';
			}

			// Check if we only apply to UNSEEN messages. If so check if there
			// any unread messages. If not, there's no point applying rules.
			if($do_rules AND @$USERPREFS['settings']['rules_only_recent']){
				$mailaccess->get_msg_ids($order_by, $ascdesc, 1, 0, 'RECENT', $num_msgs);
				$do_rules = ($num_msgs == 0) ? FALSE : TRUE;
				$search_prepend[] = 'RECENT';
			}

			$search_prepend = !empty($search_prepend) ? implode(' ', $search_prepend) . ' ' : '';

			// To rule, or not to rule....?
			if($do_rules){

				// Loop thru all the rules
				foreach(@$USERPREFS['rules'] as $rule){
					$search_string = array();

					// Generate search string
					if(!empty($rule['from']))    $criteria[] = 'from';
					if(!empty($rule['to']))      $criteria[] = 'to';
					if(!empty($rule['cc']))      $criteria[] = 'cc';
					if(!empty($rule['subject'])) $criteria[] = 'subject';
					if(!empty($rule['body']))    $criteria[] = 'body';
					//if(!empty($rule['match']))   $match = ($rule['match'] == 'any' ? 'any' : 'all'); else $match = 'all';
					//$search_string[] = ($match == 'all' ? 'ALL' : 'OR');

					for($i=0; $i<count(@$criteria); $i++){
						$string = strtr($rule[$criteria[$i]], array('"' => '\"', '\\' => '\\\\'));
						$search_string[] = strtoupper($criteria[$i]) . ' "' . $string . '"';
					}
					
					$search_string = implode(' ', $search_string);

					// Perform the actual search
					$msg_ids = $mailaccess->get_msg_ids($order_by, $ascdesc, 1, 0, $search_prepend . $search_string, $num_msgs);
					if($num_msgs > 0){
						// Perform the actions
						for($i=0; $i<count($rule['actions']); $i++){
							// FIXME Should the "mark as deleted instead of moving to deleted items" feature ever
							//       be introduced, a search for items marked as deleted will need to be performed
							//       here, the results unmarked, and then remarked as deleted after rules have completed.
							//       This is to prevent them being inadvertantly expunged.
							switch(substr($rule['actions'][$i], 0, 4)){
								case 'move':
									$folder = substr($rule['actions'][$i], strpos($rule['actions'][$i], ':') + 1);
									if($folder != 'INBOX'){
										$mailaccess->move_msg(implode(',', $msg_ids), $folder);
									}
									break;

								case 'copy':
									$folder = substr($rule['actions'][$i], strpos($rule['actions'][$i], ':') + 1);
									if($folder != 'INBOX'){
										$mailaccess->copy_msg(implode(',', $msg_ids), $HPV['folder']);
									}
									break;

								case 'mark':
									$mailaccess->setflag(implode(',', $msg_ids), 'read');
									break;

								case 'flag':
									$mailaccess->setflag(implode(',', $msg_ids), 'flagged');
									break;

								case 'dele':
									$mailaccess->delete(implode(',', $msg_ids), $message);
									break;

								default:
									// LOG
							}
						}
					}
				}
			} // End if($do_rules)
		}

		if(!empty($HGV['filter'])){
			fred::redirect('redirect.php?to=email.list.php');
		}

		/***************************************
        ** Continue with showing the list
        ***************************************/

		$_msg_ids = $mailaccess->get_msg_ids($order_by, $ascdesc, 1, 0, !empty($SESSION['search']['string']) ? $SESSION['search']['string'] : 'ALL', $num_msgs);
		$msg_ids  = array_slice($_msg_ids, $start_msg - 1, $show_per_page);

		if($num_msgs > 0){

			$SESSION['email']['message_ids'] = array();
			for($i=0; $i<count($_msg_ids); $i++){
				$SESSION['email']['message_ids'][] = array('mailbox' => $SESSION['email']['mbox'], 'msg_id' => $_msg_ids[$i]);
			}

			/***************************************
			** Make sure the start point is valid.
			***************************************/

			if(!isset($start_msg))     $start_msg = 1;
			if($start_msg > $num_msgs) $start_msg = $num_msgs - $show_per_page + 1;
			if($start_msg < 1)         $start_msg = 1;

			/***************************************
			** Populate the mail_list array. Store the $msg_ids
			** in the session so that email.view.message.php
			** can garner the next and back msg ids.
			***************************************/

			// Default for older versions
			$unread_mail = isset($USERPREFS['settings']['unread_mail']) ? $USERPREFS['settings']['unread_mail'] : 'bold';

			for($i=0; $i<count($msg_ids); $i++){
				$mail_list[$i] = $mailaccess->get_msg_summary($msg_ids[$i]);
				$mail_list[$i]['bold']      = ($mail_list[$i]['unread'] AND strpos($unread_mail, 'bold')   !== FALSE) ? 'bold' : 'normal';
				$mail_list[$i]['style']     = ($mail_list[$i]['unread'] AND strpos($unread_mail, 'italic') !== FALSE) ? 'italic' : 'normal';
				$mail_list[$i]['js_msg_id'] = md5($msg_ids[$i] . $SESSION['email']['mbox']);
				$mail_list[$i]['mbox']      = $SESSION['email']['mbox'];
				$mail_list[$i]['mbox_url']  = urlencode($SESSION['email']['mbox']);

				/***************************************
	            ** If we're in the sent items folder, 
				** replace the email/name entries with
				** to_email and to_name.
	            ***************************************/
				
				if('inbox' != strtolower($SESSION['email']['mbox']) && $SESSION['email']['mbox'] == @$USERPREFS['settings']['sent_items_folder']){
					$mail_list[$i]['email']         = $mail_list[$i]['to_email'];
					$mail_list[$i]['name']          = $mail_list[$i]['to_name'];
					$mail_list[$i]['email_urlsafe'] = $mail_list[$i]['to_urlsafe'];
				}
			}

			
			/***************************************
            ** Since we now use a subloop, the mail_list
			** becomes the subloop data with outside
			** data of nothing (outside data used for
			** headings in multiple folder search).
            ***************************************/

			$from_header = 'inbox' != strtolower($SESSION['email']['mbox']) && $SESSION['email']['mbox'] == @$USERPREFS['settings']['sent_items_folder'] ? lang('to') : lang('from');
			$mboxname    = preg_replace('/^' . preg_quote($SESSION['email']['fold'], '/') . '/', '', $SESSION['email']['mbox']);
			$mail_list   = array(array('select_all_gif' => TRUE, 'mailbox_title' => $mboxname, 'spacer' => '', 'spacer' => '', 'from_header' => $from_header, 'msgs' =>$mail_list));


		/***************************************
		** No message
		***************************************/

		}else{
			$message     = lang('no_msg');
			$from_header = 'inbox' != strtolower($SESSION['email']['mbox']) && $SESSION['email']['mbox'] == @$USERPREFS['settings']['sent_items_folder'] ? lang('to') : lang('from');
			$mboxname    = preg_replace('/^' . preg_quote($SESSION['email']['fold'], '/') . '/', '', $SESSION['email']['mbox']);
			$mail_list   = array(array('select_all_gif' => TRUE, 'mailbox_title' => $mboxname, 'spacer' => '', 'from_header' => $from_header, 'msgs' => array()));
		}

		$SESSION['email']['num_msgs'] = $num_msgs;
		$mailaccess->close();

		/***************************************
        ** Show rules link if we're in the inbox
        ***************************************/

		if($SESSION['email']['mbox'] == 'INBOX'){
			$tpl_show_rules_link = true;
		}

	}else{
		die(lang('failed_connect'));
	}
?>