<?php
/***************************************
** Filename.......: func.tpl.inc
** Copyright......: Richard Heyes 2001
** Last Modified..: 09 February 2001
***************************************/

/***************************************
** This function includes another file.
***************************************/

	function tpl_include($tpl_filename){

		global $tpl_varnames, $CONFIG, $TPL;

		for($i=0; $i<count($tpl_varnames); $i++)
			global ${$tpl_varnames[$i]};

		if(@include($TPL['path'].$tpl_filename))
			return TRUE;
		else
			$msg = 'TPL: Could not open file "'.$TPL['path'].$tpl_filename.'"';
			log::to_file($msg);
			echo $msg."\r\n";
			return new error($msg);
        }

/***************************************
** This function registers a variable(s)
** that will be replaced.
***************************************/

	function tpl_register($varnames){

		global $tpl_varnames;

		$varnames = explode(',', $varnames);

		for($i=0; $i<count($varnames); $i++)
			$tpl_varnames[] = trim($varnames[$i]);
	}

/***************************************
** This function starts a loop section.
***************************************/

	function tpl_loop_begin(){
		ob_start();
	}

/***************************************
** This function ends, parses and outputs
** a loop section.
***************************************/
	
	function tpl_loop_end($source, $tpl_db_type = NULL){

		global $TPL, $$source;

		if(!isset($tpl_db_type))
			$tpl_db_type = $TPL['db_type'];

		$html = ob_get_contents();
		ob_end_clean();

		if(is_resource($$source)){

			$func_name = 'tpl_loop_'.$tpl_db_type;
			$func_name($source, $html);

		}elseif(is_array($$source)){

			for($i=0; $i<count($$source); $i++){
				$temp_html = $html;
				reset(${$source}[$i]);
				while(list($key, $value) = each(${$source}[$i])){
					$temp_html = str_replace($TPL['start_tag'].$key.$TPL['end_tag'], $value, $temp_html);
				}

				$temp_html = str_replace($TPL['start_tag'].'_rownum_'.$TPL['end_tag'], $i, $temp_html);

				echo $temp_html;
			}
		}
	}

/***************************************
** Mysql specific function for handling
** result sets instead of arrays.
***************************************/

	function tpl_loop_mysql($source, $html){

		global $$source;

		for($i=0; $i<mysql_num_fields($$source); $i++)
			$field_names[] = mysql_field_name($$source,$i);

		while($row_data = mysql_fetch_array($$source, MYSQL_ASSOC)){
			$temp_html = $html;
			for($i=0; $i<count($field_names); $i++)
				$temp_html = str_replace($TPL['start_tag'].$field_names[$i].$TPL['end_tag'], $row_data[$field_names[$i]], $temp_html);

			echo $temp_html;
		}
	}

/***************************************
** Subloop begin function
***************************************/

	function tpl_subloop_begin(){

		ob_start();
	}

/***************************************
** Subloop end function.
***************************************/

	function tpl_subloop_end($source, $subloop_info){

		global $TPL, $$source;

		$source   =& $$source;			// This must be a reference!!
		$html     =  ob_get_contents();
		ob_end_clean();

		// This screws up the order of the headers
		// Don't know why it was here anyway
		//sort($source, SORT_NUMERIC);

		// For each of the outer loop
		for($i=0; $i<count($source); $i++){

			$new_html = '';

			if(isset($source[$i][$subloop_info])){
				sort($source[$i][$subloop_info], SORT_NUMERIC);
				// For each of the inner loop
				for($j=0; $j<count($source[$i][$subloop_info]); $j++){
	
					// Nice name for subloop info
					$info =& $source[$i][$subloop_info][$j];
	
					// For each key/value pair.
					for($k = 0; list($key, $value) = each($info); $k++){
						if($k === 0)
							$tmp_html = ltrim($html);
						$tmp_html = str_replace($TPL['start_tag'].$key.$TPL['end_tag'], $value, $tmp_html);
					}
	
					$new_html .= $tmp_html;
				}
			}	

			// Set the new html to be inserted on outer iteration.
			$source[$i][$subloop_info] = $new_html;
		}

		echo '{'.$subloop_info.'}';
	}


/***************************************
** Start compression.
***************************************/

	function tpl_compress_begin(){

		ob_start('ob_gzhandler');
	}

/***************************************
** End compression.
***************************************/

	function tpl_compress_end(){

		ob_end_flush();
	}

/***************************************
** Start to_variable function.
***************************************/

	function tpl_tovar_begin(){

		ob_start();
	}

/***************************************
** End to_variable function
***************************************/

	function tpl_tovar_end($varname){

		global $$varname;

		$html = ob_get_contents();
		ob_end_clean();

		$$varname = $html;
	}

/***************************************
** This function starts an if section.
***************************************/

	function tpl_if_begin(){
		ob_start();
	}

/***************************************
** This function ends, parses and outputs
** an if section.
***************************************/
	
	function tpl_if_end($source, $invert = FALSE){

		global $TPL, $$source;

		$html = ob_get_contents();
		ob_end_clean();

		$passed = is_array($$source) ? (count($$source) > 0) : !empty($$source);

		if($invert)
			$passed = !$passed;

		if($passed)
			echo $html;
	}
?>
