<?php
/***************************************
** Filename.....: functions.inc
** Last changed.: 31 August 2001
** Notes........:
***************************************/

/***************************************
** Determine the structure of an email.
***************************************/

	function get_msg($parts, $msg_id, $partno, $add_new_level, $is_related){

		global $CONFIG;
		return include($CONFIG['includes'].'functions/func.get_msg.inc');
	}

/***************************************
** Class that gets constructed from the above
** function.
***************************************/

	class message{
	
		var $body_plain;
		var $body_html;
		var $related;
		var $attachments;
		var $messages;

		/***************************************
		** Constructor baby.
		***************************************/

		function message(){
		
			global $CONFIG;
			return include($CONFIG['includes'].'functions/class.message.func.message.inc');
		}

		/***************************************
		** Adds an attachment to the list.
		***************************************/

		function add_attachment($c_type, $encoding, $msg_id, $partno, $size, $dparameters, $parameters, $description){

			global $CONFIG;
			return include($CONFIG['includes'].'functions/class.message.func.add_attachment.inc');
		}
	}

/***************************************
** Decodes a header according to rfc2047
***************************************/

	function decode_header($input){

		global $CONFIG;
		return include($CONFIG['includes'].'functions/func.decode_header.inc');
	}

/***************************************
** Decodes the given data
***************************************/

	function decode_body($body, $encoding){

		global $CONFIG;
		switch(trim($encoding)){
			case '7bit':				return $body;							break;
			case '8bit':				return $body;							break;
			case 'binary':				return $body;							break;
			case 'base64':				return base64_decode($body);			break;
			case 'quoted-printable':	return imap_qprint($body);				break;
			case 'other':				return $body;							break;
			default:					return $body;							break;
		}
	}

/***************************************
** Function to get the site id.
***************************************/

	function get_host_id(){
		global $CONFIG, $HVV, $SESSION, $CONFIG;
	
		if(!isset($SESSION['common']['hostinfo']) OR empty($SESSION['common']['hostinfo'])){
	
			$filename = file_exists($CONFIG['data_dir'].'local.hostinfo') ? 'local.hostinfo' : 'hostinfo';

			// Read in the hostinfo information
			include_once($CONFIG['includes'].'class.prefs.inc');
			$params['data_dir'] = $CONFIG['data_dir'];
			$prefs =& prefs::factory($CONFIG['info_storage'], $params);
			$SESSION['common']['hostinfo'] = $prefs->read($filename, FALSE);
		}
	
		$hostinfo = $SESSION['common']['hostinfo'];

		while(list($i,) = each($hostinfo)){
			if(isset($hostinfo[$i])){
				foreach($hostinfo[$i]['urls'] as $key => $value){
					if($value['host'] == $HVV['SERVER_NAME'] AND $HVV['SERVER_PORT']){
						return $i;
					}
				}
			}
		}
	
		return 1;
	}

/***************************************
** Function to get the host description
***************************************/

	function get_host_desc($host_id){
		global $CONFIG, $SESSION;

		return !empty($SESSION['common']['hostinfo'][$host_id]) ? $SESSION['common']['hostinfo'][$host_id]['description'] : FALSE;
	}

/***************************************
** Returns a full path to a template
** // FIXME This function could be a whole lot better.
***************************************/

	function get_template($template){
		global $CONFIG, $SESSION, $TPL;
	
		if(isset($SESSION['common']['tpl_set'])){
	
			// local. file present?
			if(file_exists($TPL['path'].$SESSION['common']['tpl_set'].'/local.'.$template)){
				return $TPL['path'].$SESSION['common']['tpl_set'].'/local.'.$template;
	
			// Original file?
			}elseif(file_exists($TPL['path'].$SESSION['common']['tpl_set'].'/'.$template)){
				return $TPL['path'].$SESSION['common']['tpl_set'].'/'.$template;
	
			// Fallback to templates/v-webmail/
			}else{
	
				// local. file present?
				if(file_exists($TPL['path'] . 'v-webmail/local.' . $template)){
					return $TPL['path'] . 'v-webmail/local.' . $template;
	
				// Original file?
				}elseif(file_exists($TPL['path'] . 'v-webmail/' . $template)){
					return $TPL['path'] . 'v-webmail/' . $template;
	
				}else{
					return FALSE;
				}
			}
	
		}elseif(isset($SESSION['common']['default_tpl_set'])){

			// local. file
			if(file_exists($TPL['path'] . $SESSION['common']['default_tpl_set'] . '/local.' . $template)){
				return $TPL['path'] . $SESSION['common']['default_tpl_set'] . '/local.' . $template;
	
			// Original file
			}elseif(file_exists($TPL['path'] . $SESSION['common']['default_tpl_set'] . '/' . $template)){
				return $TPL['path'] . $SESSION['common']['default_tpl_set'] . '/' . $template;

			// Fallback to v-webmail
			}else{
				// local. file present?
				if(file_exists($TPL['path'] . 'v-webmail/local.' . $template)){
					return $TPL['path'] . 'v-webmail/local.' . $template;
	
				// Original file?
				}elseif(file_exists($TPL['path'] . 'v-webmail/' . $template)){
					return $TPL['path'] . 'v-webmail/' . $template;
	
				}else{
					return FALSE;
				}
			}
	
		}else{
			return FALSE;
		}
	}

/***************************************
** Function to run the plugin functions
***************************************/

	function call_plugins($hook){
		global $CONFIG, $PLUGINS;

		if(!empty($PLUGINS[$hook])){
			for($i=0; $i<count($PLUGINS[$hook]); $i++){
		
				$plugin_name =& $PLUGINS[$hook][$i];
				$plugin_func = 'plugin_'.$plugin_name;
		
				include_once($CONFIG['includes'].'plugins/'.$hook.'/'.$plugin_name.'.inc');
				$plugin_func();
			}
		}
	}

/***************************************
** Function to sort the mail list by From:
** // FIXME Is this being used at all?
***************************************/

	function list_sort_from($a, $b){

		$a =& $a["email"];
		$b =& $b["email"];

		if($a == $b) return 0;
		return ($a < $b) ? -1 : 1;
	}

/***************************************
** Print_r Dump and Die
***************************************/

	function pdd($var){
		echo '<PRE>';
		print_r($var);
		echo '</PRE>';
		exit;
	}

/***************************************
** Var_dump Dump and Die
***************************************/

	function vdd($var){
		echo '<PRE>';
		var_dump($var);
		echo '</PRE>';
		exit;
	}

/***************************************
** Lang function returns the appropriate
** text from $LANG given an identifier.
***************************************/

	function lang($id){
		global $LANG;

		return @$LANG[strtolower($id)];
	}

/***************************************
** Saves preferences information
***************************************/

	function save_prefs($uid = null, $data = null){
		global $CONFIG, $SESSION, $USERPREFS;

		if(!isset($uid)){
			$uid = $SESSION['login']['username'].'@'.$SESSION['email']['srvr'];
		}
		
		if(!isset($data)){
			$data = $USERPREFS;
		}

		include_once($CONFIG['includes'].'class.prefs.inc');
		$prefs =& prefs::factory($CONFIG['info_storage'], $CONFIG['info_storage_params']);

		return $prefs->write($uid, $data);
	}

/***************************************
** Saves addressbook information
***************************************/

	function save_addressbook($data){
		global $CONFIG, $SESSION;

		include_once($CONFIG['includes'].'class.prefs.inc');
		$prefs =& prefs::factory($CONFIG['info_storage'], $CONFIG['info_storage_params']);

		return $prefs->write($SESSION['login']['username'].'@'.$SESSION['email']['srvr'].'.addressbook', $data);
	}

/***************************************
** Saves hostinfo information
***************************************/

	function save_hostinfo(){
		global $CONFIG, $SESSION;

		include_once($CONFIG['includes'].'class.prefs.inc');
		$prefs =& prefs::factory($CONFIG['info_storage'], $CONFIG['info_storage_params']);

		return $prefs->write('hostinfo', $SESSION['common']['hostinfo'], FALSE);
	}
?>
