<?php
/***************************************
** Filename.......: func.get_msg.inc
** Project........: Frederick
** Last Modified..: 15 October 2001
***************************************/

/***************************************
** Arguments:
**  $parts			- Parts of the message
**  $msg_id			- Message ID
**  $partno			- Current Part number
**  $add_new_level	- 
**  $is_related		- Whether we're inside a related branch
***************************************/

	global $mailaccess, $msg_struct;

	switch(strtolower($parts->ctype_primary).'/'.strtolower($parts->ctype_secondary)){

		case 'text/plain':

			if(isset($parts->headers['content-transfer-encoding']))
				$encoding = $parts->headers['content-transfer-encoding'];
			else
				$encoding = '7bit';

			if(isset($parts->disposition) AND strtolower($parts->disposition) == 'attachment'){

				if(!empty($parts->d_parameters))     $dparameters = $parts->d_parameters;      else $dparameters = array();
				if(!empty($parts->ctype_parameters)) $parameters  = $parts->ctype_parameters;  else $parameters  = array();

				if(!empty($parts->headers['content-description']))
					$description = $parts->headers['content-description'];
				else
					$description = 'Attached message';

				$msg_struct->add_attachment(
							    'text/plain',
							    $encoding,
							    $msg_id,
							    $partno,
							    strlen($parts->body),
							    $dparameters,
							    $parameters,
								$description
							   );

			}else{
				$msg_struct->body_plain  .= $parts->body;
				$msg_struct->text_charset = (isset($parts->ctype_parameters['charset'])) ? $parts->ctype_parameters['charset'] : 'ISO-8859-1';
			}

			break;

		case 'text/html':

			if(isset($parts->headers['content-transfer-encoding']))
				$encoding = strtolower($parts->headers['content-transfer-encoding']);
			else
				$encoding = '7bit';

			if(isset($parts->disposition) AND strtolower($parts->disposition) == 'attachment'){

				if(!empty($parts->d_parameters))     $dparameters = $parts->d_parameters;      else $dparameters = array();
				if(!empty($parts->ctype_parameters)) $parameters  = $parts->ctype_parameters;  else $parameters  = array();

				if(!empty($parts->headers['content-description']))
					$description = $parts->headers['content-description'];
				else
					$description = 'Attached message';

				$msg_struct->add_attachment(
							    'text/html',
							    $encoding,
							    $msg_id,
							    $partno,
							    strlen($parts->body),
							    $dparameters,
							    $parameters,
								$description
							   );
			}else{
				$msg_struct->body_html = $parts->body;
				$msg_struct->html_charset = (isset($parts->ctype_parameters['charset'])) ? $parts->ctype_parameters['charset'] : 'ISO-8859-1';
			}

			break;

		case 'multipart/report':
		case 'multipart/signed':
		case 'multipart/mixed':
			if(!isset($parts->parts) OR count($parts->parts) == 0) return;

			$prefix = ($partno != '1') ? $partno.'.' : '';

			for($i=0; $i<count($parts->parts); $i++)
				get_msg($parts->parts[$i], $msg_id, $prefix.($i+1), TRUE, FALSE);

			break;

		case 'multipart/alternative':
			if(!isset($parts->parts) OR count($parts->parts) == 0)  return;

			if($add_new_level)
				$partno = $partno.'.1';

			for($i=0; $i<count($parts->parts); $i++)
				get_msg($parts->parts[$i], $msg_id, substr($partno, 0, -1).($i+1), TRUE, FALSE);

			break;

		case 'multipart/related':
			if(!isset($parts->parts) OR count($parts->parts) == 0)  return;

			if($add_new_level)
				$partno = $partno.'.1';

			for($i=0; $i<count($parts->parts); $i++)
				get_msg($parts->parts[$i], $msg_id, substr($partno, 0, -1).($i+1), TRUE, TRUE);

			break;

		case 'message/delivery-status':
		case 'message/rfc822':
			if(isset($parts->headers['content-transfer-encoding']))
				$encoding = $parts->headers['content-transfer-encoding'];
			else
				$encoding = '7bit';

			if(!empty($parts->d_parameters))     $dparameters = $parts->d_parameters;      else $dparameters = array();
			if(!empty($parts->ctype_parameters)) $parameters  = $parts->ctype_parameters;  else $parameters  = array();

			if(!empty($parts->headers['content-description']))
				$description = $parts->headers['content-description'];
			else
				$description = 'Attached message';

			$msg_struct->add_attachment(
						    'message/'.$parts->ctype_secondary,
						    $encoding,
						    $msg_id,
						    $partno,
						    strlen($mailaccess->get_body($msg_id, $partno)),
						    $dparameters,
						    $parameters,
						    $description
						   );
			break;

		case 'multipart/digest':
			if(!isset($parts->parts) OR count($parts->parts) == 0) return;

			for($i=0; $i<count($parts->parts); $i++){
				get_msg($parts->parts[$i], $msg_id, ($i+1), TRUE, FALSE);
			}

			break;

		default:

			if(isset($parts->headers['content-transfer-encoding']))
				$encoding = $parts->headers['content-transfer-encoding'];
			else
				$encoding = '7bit';

			if(isset($parts->headers['content-id'])){
				$cid = trim($parts->headers['content-id']);
				if(substr($cid,0,1) == '<') $cid = substr($cid, 1);
				if(substr($cid,-1) == '>') $cid = substr($cid,0,-1);
			}else{
				$cid = 0;
			}

			if($is_related == TRUE){
				$msg_struct->related[] = array(
							       'c_type'   => strtolower($parts->ctype_primary).'/'.strtolower($parts->ctype_secondary),
							       'encoding' => $encoding,
							       'msg_id'   => $msg_id,
							       'part_id'  => $partno,
							       'size'     => strlen($parts->body),
							       'c_id'     => $cid
							      );
			}else{

				if(!empty($parts->d_parameters))     $dparameters = $parts->d_parameters;      else $dparameters = array();
				if(!empty($parts->ctype_parameters)) $parameters  = $parts->ctype_parameters;  else $parameters  = array();

				if(!empty($parts->headers['content-description']))
					$description = $parts->headers['content-description'];
				else
					$description = 'Attached message';

				$msg_struct->add_attachment(
							    strtolower($parts->ctype_primary).'/'.strtolower($parts->ctype_secondary),
							    $encoding,
							    $msg_id,
							    $partno,
							    strlen($parts->body),
							    $dparameters,
							    $parameters,
							    $description
							   );
			}
	}
?>
