<?php
/***************************************
** Filename.......: prepend.inc
** Project name...: Frederick
** Last Modified..: 09 January 2002
***************************************/

	error_reporting(~E_NOTICE);

/***************************************
** Includes.
***************************************/

	@include('local.config.php');
	include_once($CONFIG['includes'] .'class.fred.inc');
	include_once($CONFIG['includes'] .'class.input.inc');
	include_once($CONFIG['includes'] .'class.auth.inc');
	include_once($CONFIG['includes'] .'plugins' . DIRECTORY_SEPARATOR . 'plugin.index.inc');
	@include_once($CONFIG['includes'] .'plugins' . DIRECTORY_SEPARATOR . 'local.plugin.index.inc');
	include_once($CONFIG['includes'] .'functions.inc');
	include_once($CONFIG['includes'] .'session.inc');
	include_once($CONFIG['lang_dir'] .'lang.index.inc');

/***************************************
** Parse configuration file
***************************************/

	// Config.ini
	$filename = file_exists($CONFIG['conf_dir'] . 'local.settings.php') ? $CONFIG['conf_dir'] . 'local.settings.php' : $CONFIG['conf_dir'] . 'settings.php';
	if(filemtime($filename) > @filemtime($CONFIG['tmp_dir'] . 'settings.php.tmp') OR @!include_once($CONFIG['tmp_dir'] . 'settings.php.tmp')){
		$conf_file = 'settings.php';
		include($CONFIG['includes'] . 'parse.ini.inc');
	}

/***************************************
** Template stuff.
***************************************/

	$TPL['path']      = $CONFIG['base_dir'] . 'templates' . DIRECTORY_SEPARATOR; // Must have trailing slash!
	$TPL['db_type']   = 'mysql';
	$TPL['start_tag'] = '{';
	$TPL['end_tag']   = '}';

/***************************************
** App name/version
***************************************/

	$CONFIG['app_name'] = 'V-webmail';
	$CONFIG['app_ver']  = '1.2.3';

/***************************************
** Setup some variables for post/get/session
** arrays.
***************************************/

	$HGV =  $HTTP_GET_VARS;
	$HPV =  $HTTP_POST_VARS;
	$HSV =& $HTTP_SESSION_VARS;
	$HVV =  $HTTP_SERVER_VARS;
	$HPF =  $HTTP_POST_FILES;

	if(ini_get('register_globals')){
		$SESSION =& $session_global_var;
	}else{
		$SESSION =& $HSV['session_global_var'];
	}

/***************************************
** Create REQUEST_URI variable if needed
***************************************/

	if(!isset($HVV['REQUEST_URI'])){
		$HVV['REQUEST_URI'] = $HVV['SCRIPT_NAME'] . '?' . $HVV['QUERY_STRING'];
	}

/***************************************
** Work out the web_path variable and some
** others based upon it.
***************************************/

	$CONFIG['web_path'] = (@$HVV['HTTPS'] == 'on' ? 'https://' : 'http://') . $HVV['SERVER_NAME'] . ($HVV['SERVER_PORT'] == 80 ? '' : ':' . $HVV['SERVER_PORT']) . substr($HVV['REQUEST_URI'], 0, strrpos($HVV['REQUEST_URI'], '/') + 1);
	$CONFIG['css_path'] = $CONFIG['web_path'].'css/';
	$CONFIG['img_path'] = $CONFIG['web_path'].'images/';
	$CONFIG['js_path']  = $CONFIG['web_path'].'js/';

/***************************************
** Clear any variables created thru
** register_globals
***************************************/

	if(ini_get('register_globals')){
		foreach($HPV as $key => $value){
			if(isset($$key)){
				unset($$key);
			}
		}
		foreach($HGV as $key => $value){
			if(isset($$key)){
				unset($$key);
			}
		}
		foreach($HVV as $key => $value){
			if(isset($$key)){
				unset($$key);
			}
		}

		reset($HGV);
		reset($HPV);
		reset($HVV);
	}

/***************************************
** Check web_path for multiple trailing
** / and correct if necessary
***************************************/

	while(substr($CONFIG['web_path'], -2) === '//')
		$CONFIG['web_path'] = substr($CONFIG['web_path'], 0, -1);

/***************************************
** Get the site id.
***************************************/

	$SESSION['common']['host_id'] = get_host_id();

/***************************************
** Set the preferences parameters array
***************************************/

	$CONFIG['info_storage_params'] = array('data_dir' => $CONFIG['data_dir']);

/***************************************
** Create the mail access object
***************************************/

	if(auth::is_logged_in()){
		include_once($CONFIG['includes'] . 'class.mailaccess.inc');
		$mailaccess =& mailaccess::factory($SESSION['email']['type']);
	}


/***************************************
** Create the hostinfo and userprefs vars
***************************************/

	if(!empty($SESSION['common']['hostinfo'][$SESSION['common']['host_id']]))
		$HOSTINFO =& $SESSION['common']['hostinfo'][$SESSION['common']['host_id']];

	if(!empty($SESSION['userprefs']))
		$USERPREFS =& $SESSION['userprefs'];

/***************************************
** Determine which language file to
** include. Always includes the default
** as a psuedo fallback.
***************************************/

	if(isset($LANG)){
		unset($LANG);
	}

	// Include english lang file
	include_once($CONFIG['lang_dir'] . 'lang.en.inc');
	@include_once($CONFIG['lang_dir'] . 'local.lang.en.inc');

	// Include default lang file
	include_once($CONFIG['lang_dir'] . 'lang.' . $CONFIG['default_lang'] . '.inc');
	@include_once($CONFIG['lang_dir'] . 'local.lang.' . $CONFIG['default_lang'] . '.inc');

	if(isset($USERPREFS['settings']['lang']) AND @$USERPREFS['settings']['lang_always']){
		@include_once($CONFIG['lang_dir'] . 'lang.' . $USERPREFS['settings']['lang'] . '.inc');
		@include_once($CONFIG['lang_dir'] . 'local.lang.' . $USERPREFS['settings']['lang'] . '.inc');

	}else{

		@include_once($CONFIG['lang_dir'] . 'lang.' . $SESSION['common']['lang'] . '.inc');
		@include_once($CONFIG['lang_dir'] . 'local.lang.' . $SESSION['common']['lang'] . '.inc');
	}

/***************************************
** Magic quotes
***************************************/

	input::stripslashes($HPV);
	input::stripslashes($HGV);

	ini_set('magic_quotes_runtime', '0');
?>
